unit FormMainUnit;

interface

{$INCLUDE Global_Conditionals.inc}
{$R vxldata.res}
{$R icons.res}

{$IFDEF TIB_PLUGIN}
//TibEd doesn't support new command (yet), so PLASMA_PROJECT is useless in plug-in mode
{$UNDEF PLASMA_PROJECT}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Voxel, Menus, StdCtrls, ExtCtrls, Buttons, FormHeaderUnit, Voxel_Tools,
  Voxel3D, ShellApi, FormNewSectionSizeUnit, FormNewVxlUnit,
  ComCtrls, Registry, ToolWin, ImgList, HVA, cls_Config, cls_UndoSystem, Constants, pause, Global;

const
  NormalsPaletteOfs = TRANSPARENT + 2; // the +2 gives a space to normal -1
  NumNormals = 255;
  NumPaletteEntries = NormalsPaletteOfs + NumNormals;

type

  TPoint3D = record
     X, Y, Z: Integer;
  end;

  TFrmMain = class(TForm)
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuNew: TMenuItem;
    mnuOpen: TMenuItem;
    mnuExit: TMenuItem;
    mnuN1: TMenuItem;
    dlgOpen: TOpenDialog;
    pnlLeftBar: TPanel;
    lblSection: TLabel;
    pnlTools: TPanel;
    lblTols: TLabel;
    pnlSection: TPanel;
    lblPalette: TLabel;
    cboSections: TComboBox;
    btnPaint: TSpeedButton;
    BtnFill: TSpeedButton;
    btnRect: TSpeedButton;
    btnErase: TSpeedButton;
    cnvPalette: TPaintBox;
    pnlRightBar: TPanel;
    pnlMainWindow: TPanel;
    splViews: TSplitter;
    lblView0: TLabel;
    lblView1: TLabel;
    lblView2: TLabel;
    lblView3: TLabel;
    cnvView2: TPaintBox;
    pnlView3: TPanel;
    sclView3Y: TScrollBar;
    sclView3X: TScrollBar;
    sclView3Z: TScrollBar;
    cnvView3: TPaintBox;
    mnuZoomPopup: TPopupMenu;
    mnuZoomIn: TMenuItem;
    mnuZoomOut: TMenuItem;
    mnuZoomFit: TMenuItem;
    N1: TMenuItem;
    mnuSelectColour: TMenuItem;
    mnuRefreshView: TMenuItem;
    mnuZoomInfo: TMenuItem;
    cnvView1: TPaintBox;
    mnuView: TMenuItem;
    mnuRefreshScreen: TMenuItem;
    mnuZoomFitAll: TMenuItem;
    pnlViewScroll0: TPanel;
    cnvViewScroll0: TPaintBox;
    mnuShowScroll: TMenuItem;
    pnlViewScroll1: TPanel;
    cnvViewScroll1: TPaintBox;
    pnlViewScroll2: TPanel;
    cnvViewScroll2: TPaintBox;
    mnuDirectionPopup: TPopupMenu;
    mnuEdit: TMenuItem;
    mnuDirTowards: TMenuItem;
    mnuDirAway: TMenuItem;
    mnuCancel1: TMenuItem;
    mnuCancel2: TMenuItem;
    pnlPalette: TPanel;
    pnlActiveColour: TPanel;
    lblActiveColour: TLabel;
    pnlStatusbar: TPanel;
    pnlZ: TPanel;
    pnlX: TPanel;
    pnlY: TPanel;
    lblPosition: TLabel;
    lblOpenFile: TLabel;
    lbl_spacer1: TLabel;
    pnlOpenFile: TPanel;
    N2: TMenuItem;
    mnuDrawMode: TMenuItem;
    mnuSpectrum: TMenuItem;
    mnuViewModeFull: TMenuItem;
    mnuViewModeCrossSection: TMenuItem;
    mnuViewModeEmphasiseDepth: TMenuItem;
    mnuSpectrumColours: TMenuItem;
    mnuSpectrumNormals: TMenuItem;
    mnuSection: TMenuItem;
    mnuSectionRemoveRedundantVoxels: TMenuItem;
    mnuSaveAs: TMenuItem;
    dlgSaveAs: TSaveDialog;
    pnlBusyMsg: TPanel;
    lblBusyMsg: TLabel;
    imgBusyMsg: TImage;
    N3: TMenuItem;
    mnuSectionClear: TMenuItem;
    mnuSectionDelete: TMenuItem;
    mnuSectionNew: TMenuItem;
    mnuSectionNewSection: TMenuItem;
    mnuSectionNewImportfromanotherModel: TMenuItem;
    mnuSectionNewCopyofthisSection: TMenuItem;
    mnuSectionResize: TMenuItem;
    mnuModel: TMenuItem;
    mnuModelHVA: TMenuItem;
    mnuSectionAutonormals: TMenuItem;
    Showpositiondebug1: TMenuItem;
    debug: TPopupMenu;
    Close1: TMenuItem;
    ZZPanel: TPanel;
    Edit1: TEdit;
    Sites: TMenuItem;
    mnuReopen: TMenuItem;
    will: TMenuItem;
    OlafvanderSpek1: TMenuItem;
    Plasmadroidforupdates1: TMenuItem;
    N4: TMenuItem;
    Ra2ForumPL1: TMenuItem;
    BGCNC1: TMenuItem;
    ToolBar1: TToolBar;
    BarOpen: TToolButton;
    BarNew: TToolButton;
    BarSaveAs: TToolButton;
    BarReopen: TToolButton;
    BarClose: TPopupMenu;
    mnuBarReopen: TMenuItem;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ShowMenuBar1: TMenuItem;
    ToolButton7: TToolButton;
    mnuSave: TMenuItem;
    mnuEditM: TMenuItem;
    mnuUndo: TMenuItem;
    LoadPrmFile: TButton;
    Zoom2fit: TButton;
    Options1: TMenuItem;
    mnuOptions: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    mnuBarUndo: TToolButton;
    ToolButton10: TToolButton;
    PlanetCNC1: TMenuItem;
    Ra2ModMakers1: TMenuItem;
    TibEdNetforpluginupdates1: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuBarRedo: TToolButton;
    mnuRedo: TMenuItem;
    mnuFlipX: TMenuItem;
    mnuFlipY: TMenuItem;
    mnuFlipZ: TMenuItem;
    N7: TMenuItem;
    mnuMirrorHoriz1: TMenuItem;
    mnuMirrorVert1: TMenuItem;
    mnuMirror: TMenuItem;
    mnuMirrorHoriz2: TMenuItem;
    mnuMirrorVert2: TMenuItem;
    mnuFlip: TMenuItem;
    mnuNudge: TMenuItem;
    mnuNudge1: TMenuItem;
    mnuNudge2: TMenuItem;
    mnuNudge3: TMenuItem;
    mnuNudge4: TMenuItem;
    butSectionEditHeader: TSpeedButton;
    mnuSectionResizeContent: TMenuItem;
    cnvView0PopUp: TPopupMenu;
    zoomIn: TMenuItem;
    zoomOut: TMenuItem;
    cnvView0: TPaintBox;
    AboutHVAPlugin: TMenuItem;
    btnLine: TSpeedButton;
    btnZoom: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    pnlZoom: TPanel;
    BtnZoom1x: TSpeedButton;
    BtnZoom2x: TSpeedButton;
    BtnZoom4x: TSpeedButton;
    pnlBrush: TPanel;
    btnBrush1: TSpeedButton;
    btnBrush2: TSpeedButton;
    btnBrush3: TSpeedButton;
    btnBrush4: TSpeedButton;
    pnlRect: TPanel;
    btnRect1: TSpeedButton;
    btnRect2: TSpeedButton;
    procedure mnuExitClick(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cnvPalettePaint(Sender: TObject);
    procedure pnlRightBarResize(Sender: TObject);
    procedure lblView1Click(Sender: TObject);
    procedure lblView2Click(Sender: TObject);
    procedure cnvView1Paint(Sender: TObject);
    procedure cnvView2Paint(Sender: TObject);
    procedure cnvView0Paint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure splViewsMoved(Sender: TObject);
    procedure mnuZoomFitClick(Sender: TObject);
    procedure mnuNewClick(Sender: TObject);
    procedure mnuRefreshViewClick(Sender: TObject);
    procedure mnuSelectColourClick(Sender: TObject);
    procedure mnuZoomInClick(Sender: TObject);
    procedure mnuZoomOutClick(Sender: TObject);
    procedure mnuZoomPopupPopup(Sender: TObject);
    procedure mnuRefreshScreenClick(Sender: TObject);
    procedure mnuZoomFitAllClick(Sender: TObject);
    procedure cboSectionsClick(Sender: TObject);
    procedure cnvPaletteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvViewScrollPaint(Sender: TObject);
    procedure mnuShowScrollClick(Sender: TObject);
    procedure mnuDirectionPopupPopup(Sender: TObject);
    procedure mnuEditClick(Sender: TObject);
    procedure mnuDirTowardsClick(Sender: TObject);
    procedure mnuDirAwayClick(Sender: TObject);
    procedure cnvViewScroll0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvViewScroll1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvViewScroll2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure mnuDrawModeClick(Sender: TObject);
    procedure mnuViewModeFullClick(Sender: TObject);
    procedure mnuViewModeCrossSectionClick(Sender: TObject);
    procedure mnuViewModeEmphasiseDepthClick(Sender: TObject);
    procedure mnuSpectrumColoursClick(Sender: TObject);
    procedure mnuSpectrumNormalsClick(Sender: TObject);
    procedure mnuSpectrumClick(Sender: TObject);
    procedure butSectionEditHeaderClick(Sender: TObject);
    procedure cnvView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvView2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvView0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cnvView0MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure cnvView0MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuSectionRemoveRedundantVoxelsClick(Sender: TObject);
    procedure mnuSaveAsClick(Sender: TObject);
    procedure cnvView3Paint(Sender: TObject);
    procedure MoveView3D(Sender: TObject);
    procedure btnPaintClick(Sender: TObject);
    procedure btnEraseClick(Sender: TObject);
    procedure mnuSectionClearClick(Sender: TObject);
    procedure mnuSectionResizeClick(Sender: TObject);
    procedure mnuSectionNewSectionClick(Sender: TObject);
    procedure mnuModelHVAClick(Sender: TObject);
    procedure Showpositiondebug1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
//    procedure mnuLastOpenedClick(Sender: TObject);
    procedure willClick(Sender: TObject);
    procedure OlafvanderSpek1Click(Sender: TObject);
    procedure Plasmadroidforupdates1Click(Sender: TObject);
    procedure Ra2ForumPL1Click(Sender: TObject);
    procedure BGCNC1Click(Sender: TObject);
    procedure BarReopenClick(Sender: TObject);
    procedure mnuBarReopenClick(Sender: TObject);
    procedure ShowMenuBar1Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure cnvView0Click(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuUndoClick(Sender: TObject);
    procedure btnRectClick(Sender: TObject);
    procedure LoadPrmFileClick(Sender: TObject);
    procedure notClickedClick(Sender: TObject);
    procedure Zoom2fitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuOptionsClick(Sender: TObject);
    procedure PlanetCNC1Click(Sender: TObject);
    procedure Ra2ModMakers1Click(Sender: TObject);
    procedure TibEdNetforpluginupdates1Click(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuRedoClick(Sender: TObject);
    procedure mnuFlipXClick(Sender: TObject);
    procedure mnuFlipYClick(Sender: TObject);
    procedure mnuFlipZClick(Sender: TObject);
    procedure mnuMirrorHoriz1Click(Sender: TObject);
    procedure mnuMirrorVert1Click(Sender: TObject);
    procedure mnuNudge1Click(Sender: TObject);
    procedure mnuSectionDeleteClick(Sender: TObject);
    procedure mnuSectionResizeContentClick(Sender: TObject);
    procedure zoomInClick(Sender: TObject);
    procedure zoomOutClick(Sender: TObject);
    procedure btnRect1Click(Sender: TObject);
    procedure btnRect2Click(Sender: TObject);
    procedure AboutHVAPluginClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnZoomClick(Sender: TObject);
    procedure btnLineClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure BtnFillClick(Sender: TObject);
    procedure BtnZoom2xClick(Sender: TObject);
    procedure BtnZoom1xClick(Sender: TObject);
    procedure BtnZoom4xClick(Sender: TObject);
    procedure btnBrush1Click(Sender: TObject);
    procedure btnBrush2Click(Sender: TObject);
    procedure btnBrush3Click(Sender: TObject);
    procedure btnBrush4Click(Sender: TObject);
    procedure BtnFloodAClick(Sender: TObject);
    procedure BtnFloodBClick(Sender: TObject);
    procedure cnvPaletteClick(Sender: TObject);
    procedure BtnFloodCClick(Sender: TObject);
    procedure mnuSectionAutonormalsApply(Sender: TObject);
  private
    UndoSystem: TUndoSystem;
    mnuHistory: Array[0..HistoryDepth-1] of TMenuItem;

    { Private declarations }
    Palette: array[0..NumPaletteEntries] of TColor; // element 256 is for TRANSPARENT
                                      // elements after 256 are for normals
    ActiveColour, // index in Palette[]
    ActiveNormalsCount,
    ActiveNormal: Integer;
    // modes
    DrawMode: EDrawMode;
    File2Save,File2SaveFriendly: string;
    Clicked: Boolean;
    ClickMode: EClickMode;
    SpectrumMode: ESpectrumMode;
    ViewMode: EViewMode;
    ClickCount: integer;
    MagnifyZoom: integer;
    BrushMode: Integer;
    FloodMode: Integer;
    RectPoint: TPoint3D;
    LastFloodPoint: TPoint3D;
//    xposC,yposC,zposC: integer;
    // other
    LastClick: array[0..2] of TPoint3D; // one per 2D screen
    ActiveSection: TVoxelSection;
    View3D: TVoxel3D;
    MajorRepaintFlag, // used by procedure MajorRepaint only!
    isMouseLeftDown,
    isEditable: Boolean;
    // arrays to more easily access the three windows
    cnvView: array[0..3] of TPaintBox;
    pnlViewScroll: array[0..2] of TPanel;
    lblView: array[0..2] of TLabel;
    cnvViewScroll: array[0..2] of TPaintBox;
    // methods
    procedure HideToolPanels;
    procedure SyncViews;
    procedure ActivateView(Idx: Integer);
    procedure PaintView(WndIndex: Integer; var Cnv: TPaintBox; var View: TVoxelView);
    procedure PaintThumb(WndIndex: Integer);
    procedure MajorRepaint; overload; // repaints all views, even backgrounds
    procedure MajorRepaint(WndIndex: Integer); overload; // repaints just this window, even background
    procedure MinorRepaint; overload; // repaints all views, but not backgrounds
    procedure MinorRepaint(WndIndex: Integer); overload;
    procedure MajorRefresh;
    procedure RefreshAll;
    procedure ZoomToFit(WndIndex: Integer);
    procedure CentreZoom(WndIndex: Integer); overload;
    procedure CentreZoom(WndIndex, X, Y: Integer); overload;
    procedure ShowScroll(WndIndex: Integer; Toggle: Boolean);
    procedure SetActiveColour(Col: Integer);
    procedure SetActiveNormal(Norm: Integer);
    procedure SetEditable(ok: Boolean);
    procedure TranslateClick(WndIndex, sx, sy: Integer; var lx, ly, lz: Integer);
    procedure MoveCursor(lx, ly, lz: Integer);
    procedure ShowBusyMessage(Msg: string);
    procedure HideBusyMessage;
    procedure UpdateHistoryMenu;
    procedure UpdateUndoStatus;
    procedure mnuHistoryClick(Sender: TObject);
    procedure OpenHyperlink(HyperLink: PChar);
    procedure LoadNormalsSchemesMenu;
    procedure SetNormalsPalette;
  public
    { Public declarations }
    Voxel: TVoxel;
    procedure OpenVoxelFile(FName: string);
    procedure LoadPalette;
{$IFDEF TIB_PLUGIN}
    procedure PlugInit(FileName, FriendlyName: String);
{$ENDIF}
    procedure SetNormalsRamp(NumNormals: Integer); // either 32 or 64
    procedure OpenAFile(FileName: String; FriendlyName: String='');
    procedure CreateNewVoxel(FileName: String);
  end;

var
  FrmMain: TFrmMain;


implementation

uses Math, LoadForm, FormOptions, FormFullResize,
{$IFDEF PLASMA_PROJECT}
  FormNewProject,
{$ENDIF}
  TempFile;

{$R *.DFM}

const ViewName: array[0..5] of string = (
      ' Back to Front',
      ' Front to Back',
      ' Right to Left',
      ' Left to Right',
      ' Top to Bottom',
      ' Bottom to Top');

procedure TFrmMain.CreateNewVoxel(FileName: String);
var
  FrmNew: TFrmNew;
  Res: TResourceStream;
  S: String;
begin
  OpenAFile('');
  if FileName='' then begin
    Res := TResourceStream.Create(hInstance,'VXLDATA',RT_RCDATA);
    File2SaveFriendly :='';
    File2Save := 'unnamed.vxl';
    pnlOpenFile.Caption := ' -- Unnamed.vxl --';
    S:=GiveTempFileName;
    Res.SaveToFile(S);
    OpenVoxelFile(S);
    DeleteFile(S);
    Res.Free;
  end else begin
    Res := TResourceStream.Create(hInstance,'VXLDATA',RT_RCDATA);
    Res.SaveToFile(FileName);
    File2Save := ExtractFileName(FileName);
    File2SaveFriendly :='';
    OpenVoxelFile(FileName);
    Res.Free;
  end;
    cnvView0.Enabled := false;
    ActiveSection.Clear;
    MajorRefresh;
    cnvView0.Enabled := true;
    FrmNew:=TFrmNew.Create(Self);
    with FrmNew do
        begin
         FrmNew.Caption := ' New Voxel File';
         grpCurrentSize.Left := 400;
         grpNewSize.Left := 7;
         grpNewSize.Width := 201;
         grpCurrentSize.Visible := true;

          x := ActiveSection.Tailer.XSize;
          y := ActiveSection.Tailer.YSize;
          z := ActiveSection.Tailer.ZSize;
          Changed:=True;
          ShowModal;
          if changed then begin
           SetEditable(false);
           ActiveSection.Resize(x,y,z);
           SetEditable(true);
          end;
        end;

  cboSectionsClick(Self);
  FrmMain.Caption := 'Voxel Editor II - '+File2Save;
  mnuSave.Enabled := true;
  BarSaveAs.Enabled := true;
  Clicked:=True;
  //new file - erase undo information
  UndoSystem.Clear;
  UpdateUndoStatus;

  FrmNew.Hide;
  FrmNew.Free;
end;

procedure TFrmMain.LoadPalette;
type TRGBTriplet = packed record
     red, green, blue: Byte;
end;
var F: File of TRGBTriplet;
    Col: TRGBTriplet;
    i: Integer;
    Res: TResourceStream;
    fs: TMemoryStream;

begin
 Clicked := false;

    Res := TResourceStream.Create(hInstance,'PALETTE',RT_RCDATA);
    fs:=TMemoryStream.Create;
    Res.SaveToStream(fs);
    Res.Free;

    fs.Seek(0,soFromBeginning);
    for i:=0 to 255 do begin
      fs.Read(Col,SizeOf(Col));
        with Col do begin
          red := red shl 2;
          green := green shl 2;
          blue := blue shl 2;
          Palette[i] := RGB(red,green,blue);
        end;
     end;
     fs.Free;

{     // open palette file
     AssignFile(F,FName);
     FileMode := 0; // read only
     Reset(F); // file of byte
     for i:= 0 to 255 do begin
         Read(F,Col);
         with Col do begin
              red := red shl 2;
              green := green shl 2;
              blue := blue shl 2;
              Palette[i] := RGB(red,green,blue);
         end;
     end;
     CloseFile(F);}
     Palette[TRANSPARENT] := RGB(140,170,235);
     SetNormalsRamp(63);
     mnuModel.Enabled := true;


end;

procedure TFrmMain.SetNormalsRamp(NumNormals: Integer); // either 32 or 64
var i: Integer;
    Scale: Real;
    Col: Byte;
begin
     ActiveNormalsCount := NumNormals;
     Scale := 255 / ActiveNormalsCount; // graduations in brightness
     Palette[NormalsPaletteOfs - 1] := clRed; // to emphasise normal -1
     for i := 0 to ActiveNormalsCount do begin
         Col := Round(i * Scale);
//         CO:=RGB(Col,Col mod ActiveNormalsCount,0 - Col);
         Palette[NormalsPaletteOfs + i] := RGB(Col,Col mod ActiveNormalsCount,0 - Col);
     end;
     for i := Succ(ActiveNormalsCount) to NumNormals do
        Palette[NormalsPaletteOfs + i] := clGreen;
end;

procedure TFrmMain.SetActiveColour(Col: Integer);
begin
     ActiveColour := Col;
     pnlActiveColour.Color := Palette[ActiveColour];
     lblActiveColour.Caption := IntToStr(ActiveColour) + ' (0x' + IntToHex(ActiveColour,3) + ')';
     cnvPalette.Repaint;
end;

procedure TFrmMain.SetActiveNormal(Norm: Integer);
begin
     // check bounds!
     if Norm > ActiveNormalsCount then Exit;
     // set it then
     ActiveNormal := Norm;
     pnlActiveColour.Color := Palette[ActiveNormal + NormalsPaletteOfs];
     lblActiveColour.Caption := IntToStr(ActiveNormal) + ' (0x' + IntToHex(ActiveNormal,3) + ')';
     cnvPalette.Repaint;
end;

procedure TFrmMain.ZoomToFit(WndIndex: Integer);
var Width, Height: Integer;
begin
     if not isEditable then Exit;
     Width := cnvView[WndIndex].Width;
     Height := cnvView[WndIndex].Height;
     with ActiveSection.Viewport[WndIndex] do begin
          Left := 0;
          Top := 0;
          Zoom := Trunc(Min(Width / ActiveSection.View[WndIndex].Width,Height / ActiveSection.View[WndIndex].Height));
          if Zoom <= 0 then
             Zoom := 1;
     end;
end;

procedure TFrmMain.CentreZoom(WndIndex: Integer);
var Width, Height, x, y: Integer;
begin
     if not isEditable then Exit;
     Width := cnvView[WndIndex].Width;
     Height := cnvView[WndIndex].Height;
     with ActiveSection.Viewport[WndIndex] do begin
          x := ActiveSection.View[WndIndex].Width * Zoom;
          if x > Width then
             Left := 0 - ((x - Width) div 2)
          else
              Left := (Width - x) div 2;
          y := ActiveSection.View[WndIndex].Height * Zoom;
          if y > Height then
             Top := 0 - ((y - Height) div 2)
          else
              Top := (Height - y) div 2;
     end;
end;

procedure TFrmMain.CentreZoom(WndIndex, X, Y: Integer);
var screenx, screeny,
    lx, ly,
    maxx, maxy: Integer;
    sx, sy: Real;
    v: TVoxelView;
    vport: TViewport;
    Changed: Boolean;
begin
     Changed := False; // assume not
     v := ActiveSection.View[WndIndex];
     vport := ActiveSection.Viewport[WndIndex];
     // determine amount of movement allowed
     screenx := cnvView[WndIndex].Width div vport.Zoom; // logical width of screen
     screeny := cnvView[WndIndex].Height div vport.Zoom;
     // can scroll sideways?
     if (screenx < v.Width) then begin
        maxx := v.Width - screenx; // logical coord
        sx := Trunc(X / (cnvViewScroll[WndIndex].Width / v.Width));
        lx := Trunc(sx - (screenx / 2));
        lx := Max(Min(lx,maxx),0);
        lx := 0 - (lx * vport.Zoom); // convert to physical coord
        if lx <> vport.Left then begin
           vport.Left := lx;
           Changed := True;
        end;
     end;
     // can scroll up or down?
     if (screeny < v.Height) then begin
        maxy := v.Height - screeny; // logical coord
        sy := Trunc(Y / (cnvViewScroll[WndIndex].Height / v.Height));
        ly := Trunc(sy - (screeny / 2));
        ly := Max(Min(ly,maxy),0);
        ly := 0 - (ly * vport.Zoom); // convert to physical coord
        if ly <> vport.Top then begin
           vport.Top := ly;
           Changed := True;
        end;
     end;
     if Changed then begin
        ActiveSection.Viewport[WndIndex] := vport; // just a record!
        MajorRepaint(WndIndex);
     end;
end;

procedure TFrmMain.SyncViews;
begin
     lblView0.Caption := ViewName[ActiveSection.View[0].GetViewNameIdx];
     lblView1.Caption := ViewName[ActiveSection.View[1].GetViewNameIdx];
     lblView2.Caption := ViewName[ActiveSection.View[2].GetViewNameIdx];
     //MajorRepaint;
end;

procedure TFrmMain.OpenVoxelFile(FName: string);
var i: Integer;
begin
     SetEditable(False);
     cboSections.Clear;
     Voxel.Free;
     Voxel := TVoxel.Create;
     Voxel.LoadFromFile(FName);
     // test that load was ok
     if not Voxel.isOpen then begin
          // trust a message has already been shown
          pnlOpenFile.Caption := ' -none- ';
          Exit;
     end;
     pnlOpenFile.Caption := ' ' + FName + ' ';
     Self.Caption:='Voxel Editor II - '+ExtractFileName(FName);
     if File2SaveFriendly<>'' then begin //TibEd plugin filename specified
       pnlOpenFile.Caption:=' ' + File2SaveFriendly + ' ';
       Self.Caption:='Voxel Editor II - '+File2SaveFriendly;
     end;
     // load all the section names into the Sections menu
     for i := 0 to (Voxel.Header.NumSections - 1) do
         cboSections.Items.Add(Voxel.Section[i].Name);
     cboSections.ItemIndex := 0; // select first section to edit
     cboSectionsClick(Self);
     SyncViews;
     ShowScroll(0,False);
     ShowScroll(1,False);
     ShowScroll(2,False);
     SetEditable(True);
     mnuZoomFitAllClick(Self);
     voxel.setSpectrum(SpectrumMode);        
     MajorRefresh;
     // done
end;

procedure TFrmMain.mnuExitClick(Sender: TObject);
begin
  Close
end;


procedure TFrmMain.mnuOpenClick(Sender: TObject);
//label Open;
begin
  //first, ask for 'do you want to save first?'
  OpenAFile('');
  dlgOpen.FileName:='';
  if dlgOpen.Execute then begin
    if FileExists(dlgOpen.FileName) then begin
      Clicked:=False; //otherwise 'do you want to save' will be asked again!
      OpenAFile(dlgOpen.FileName);
    end;
  end;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var i: Integer;
begin
     //--- For Rectangle tool clickount
     clickcount := 0;
     //---
     isMouseLeftDown := False;

     //I changed this so it no longer loads the palette from file.
     //it now loads it from the resource string by default.
     //However, this sub also checks to see in the registry if it should
     //be overridden.
     LoadPalette;

     ActiveColour := 16;
     Voxel := TVoxel.Create; // an empty voxel
     // init the quick-view-access arrays
     cnvView[0] := cnvView0;
     cnvView[1] := cnvView1;
     cnvView[2] := cnvView2;
     cnvView[3] := cnvView3;
     lblView[0] := lblView0;
     lblView[1] := lblView1;
     lblView[2] := lblView2;
     pnlViewScroll[0] := pnlViewScroll0;
     pnlViewScroll[1] := pnlViewScroll1;
     pnlViewScroll[2] := pnlViewScroll2;
     cnvViewScroll[0] := cnvViewScroll0;
     cnvViewScroll[1] := cnvViewScroll1;
     cnvViewScroll[2] := cnvViewScroll2;
     // a way of stopping Invalidate/Update when repainting; causes problems, see MajorRepaint
     for i := 0 to 2 do begin
         cnvView[i].ControlStyle := cnvView[i].ControlStyle + [csOpaque];
         cnvViewScroll[i].ControlStyle := cnvViewScroll[i].ControlStyle + [csOpaque];
     end;
     cnvPalette.ControlStyle := cnvPalette.ControlStyle + [csOpaque];
     // default modes
     DrawMode := ModeDraw;
     ClickMode := ModeSingleClick;
     SpectrumMode := ModeColours;
     ViewMode := ModeEmphasiseDepth; //ModeCrossSection;
     // and disable all visible components, as no voxel file loaded
     SetEditable(False);
     View3D := nil;

     //Init the history/reopen system:
     Config:=TConfiguration.Create;
     for i:=HistoryDepth - 1 downto 0 do begin
       mnuHistory[i]:=TMenuItem.Create(Self);
       mnuHistory[i].OnClick:=mnuHistoryClick;
       mnuReOpen.Insert(0,mnuHistory[i]);
     end;
     UpdateHistoryMenu;
     UndoSystem:=TUndoSystem.Create;
     UpdateUndoStatus;

     //Init the normals options
     if LoadNormalsSchemes > 0 then
        LoadNormalsSchemesMenu
     else
        mnuSectionAutonormals.Enabled := False;

//TibEd plugin modifications (deactivate things user shouldn't use while in plug-in mode)

{$IFDEF TIB_PLUGIN}

// Deactivate HVA menu entry, because this should be deactivated when in plug-in mode!
      mnuModel.Visible:=False;
      mnuModelHVA.Visible:=False;
      ToolButton5.Visible:=False;
// Deactivate loading and saving
      mnuOpen.Visible:=False;
      BarOpen.Visible:=False;
      mnuSaveAs.Visible:=False;
      mnuNew.Visible:=False;
      BarNew.Visible:=False;
//      mnuLastOpened.Visible:=False;
      mnuReOpen.Visible:=False;
      BarReOpen.Visible:=False;
// no config in plug-in mode
      Options1.Visible:=False;
      ToolButton9.Visible:=False;
{$ENDIF}

end;

{$IFDEF TIB_PLUGIN}
procedure TFrmMain.PlugInit(FileName: String; FriendlyName: String);
begin
  if FileExists(FileName) then begin
    OpenAFile(FileName,FriendlyName);
  end;
end;
{$ENDIF}

procedure SplitColour(raw: TColor; var red, green, blue: Byte);
begin
     red := (raw and $00FF0000) shr 16;
     green := (raw and $0000FF00) shr 8;
     blue := raw and $000000FF;
end;

procedure TFrmMain.cnvPalettePaint(Sender: TObject);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
    r: TRect;
    red, green, blue, mixcol: Byte;
begin
  if SpectrumMode = ModeColours then begin
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     idx := 0;
     for i := 0 to 8 do begin
         r.Left := Trunc(i * colwidth);
         r.Right := Ceil(r.Left + colwidth);
         for j := 0 to 31 do begin
             r.Top := Trunc(j * rowheight);
             r.Bottom := Ceil(r.Top + rowheight);
             with cnvPalette.Canvas do begin
                  Brush.Color := Palette[idx];
                  if Idx = ActiveColour then begin // the current pen
                     SplitColour(Palette[idx],red,green,blue);
                     mixcol := (red + green + blue);
                     Pen.Color := RGB(128 + mixcol,255 - mixcol, mixcol);
                     //Pen.Mode := pmNotXOR;
                     Rectangle(r.Left,r.Top,r.Right,r.Bottom);
                     MoveTo(r.Left,r.Top);
                     LineTo(r.Right,r.Bottom);
                     MoveTo(r.Right,r.Top);
                     LineTo(r.Left,r.Bottom);
                  end else
                      FillRect(r);
             end;
             Inc(Idx);
         end;
     end;
  end else begin // SpectrumMode = ModeNormals
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     // clear background
     r.Left := 0;
     r.Right :=cnvPalette.Width;
     r.Top := 0;
     r.Bottom := cnvPalette.Height;
     with cnvPalette.Canvas do begin
          Brush.Color := clBtnFace;
          FillRect(r);
     end;
     // and draw Normals palette
     idx := 0;
     for i := 0 to 8 do begin
         r.Left := Trunc(i * colwidth);
         r.Right := Ceil(r.Left + colwidth);
         for j := 0 to 31 do begin
             r.Top := Trunc(j * rowheight);
             r.Bottom := Ceil(r.Top + rowheight);
             with cnvPalette.Canvas do begin
                  Brush.Color := Palette[NormalsPaletteOfs + idx - 1];
                  FillRect(r);
             end;
             Inc(idx);
             if idx > ActiveNormalsCount then Break;
         end;
         if idx > ActiveNormalsCount then Break;
     end;
  end;
end;

procedure TFrmMain.pnlRightBarResize(Sender: TObject);
var rowheight: Integer;
begin
     // have to scale the three mini viewports equally
     rowheight := Round(pnlRightBar.Height / 3) - lblView1.Height;
     cnvView1.Height := rowheight;
     cnvView2.Height := rowheight;
     FormResize(Sender); // this will cause a repaint etc
     // cnvView3.align = client
end;

procedure TFrmMain.ActivateView(Idx: Integer);
var swapView: TVoxelView;
    //swapViewport: TViewport;
    swapThumb: TThumbNail;
begin
     with ActiveSection do begin
          swapView := View[0];
          View[0] := View[Idx];
          View[Idx] := swapView;
          //swapViewPort := ViewPort[0];
          //Viewport[0] := Viewport[Idx];
          //Viewport[Idx] := swapViewport;
          swapThumb := Thumb[0];
          Thumb[0] := Thumb[Idx];
          Thumb[Idx] := swapThumb;
     end;
     SyncViews;
     ZoomToFit(0);
     CentreZoom(0);
     ShowScroll(0,False);
     MajorRepaint(0);
     ZoomToFit(Idx);
     CentreZoom(Idx);
     ShowScroll(Idx,False);
     MajorRepaint(Idx);
end;

procedure TFrmMain.lblView1Click(Sender: TObject);
begin
     ActivateView(1);
end;

procedure TFrmMain.lblView2Click(Sender: TObject);
begin
     ActivateView(2);
end;

procedure TFrmMain.PaintView(WndIndex: Integer; var Cnv: TPaintBox; var View: TVoxelView);
var x, y: Integer;
    r: TRect;
    PalIdx, PalOfs: Word;
    Viewport: TViewport;
begin
     if SpectrumMode = ModeColours then
        PalOfs := 0
     else
         PalOfs := NormalsPaletteOfs;
     if not Cnv.Enabled then begin // draw it empty then
        with Cnv.Canvas do begin
             r.Left := 0;
             r.Top := 0;
             r.Right := Cnv.Width;
             r.Bottom := Cnv.Height;
             Brush.Color := clBtnFace;
             FillRect(r);
        end;
        Exit; // don't do anything else then
     end;
     if not Voxel.isOpen then Exit;
     if View = nil then Exit;
     Viewport := ActiveSection.Viewport[WndIndex];
{    if MajorRepaintFlag then begin
        with Cnv.Canvas do begin // later can improve this to stop flicker
             r.Left := 0;
             r.Top := 0;
             r.Right := Cnv.Width;
             r.Bottom := Cnv.Height;
             Brush.Color := Palette[TRANSPARENT]; // the clear colour
             FillRect(r);
        end;
     end; }
// fill margins around shape
     Cnv.Canvas.Brush.Color := Palette[TRANSPARENT]; // in case used
     // left side?
     if (Viewport.Left > 0) then begin
        with r do begin // left size
             Left := 0;
             Right := Viewport.Left;
             Top := 0;
             Bottom := Cnv.Height;
        end;
        with Cnv.Canvas do
             FillRect(r);
     end;
     // right side?
     if (Viewport.Left + (Viewport.Zoom * View.Width)) < Cnv.Width then begin
        with r do begin // right side
             Left := Viewport.Left + (Viewport.Zoom * View.Width);
             Right := Cnv.Width;
             Top := 0;
             Bottom := Cnv.Height;
        end;
        with Cnv.Canvas do
             FillRect(r);
     end;
     // top
     if (Viewport.Top > 0) then begin
        with r do begin // top
             Left := 0;
             Right := Cnv.Width;
             Top := 0;
             Bottom := Viewport.Top;
        end;
        with Cnv.Canvas do
             FillRect(r);
     end;
     // bottom
     if (Viewport.Top + (Viewport.Zoom * View.Height)) < Cnv.Height then begin
        with r do begin // bottom
             Top := Viewport.Top + (Viewport.Zoom * View.Height);
             Bottom := Cnv.Height;
             Left := 0;
             Right := Cnv.Width;
        end;
        with Cnv.Canvas do
             FillRect(r);
     end;
     // paint view
     Cnv.Canvas.Pen.Color := clRed; //Palette[Transparent];
     for x := 0 to (View.Width - 1) do begin
         r.Left := (x * Viewport.Zoom) + Viewport.Left;
         r.Right := r.Left + Viewport.Zoom;
         if r.Right < 0 then Continue; // not visible checks
         if r.Left > Cnv.Width then Continue; // not visible checks
         r.Top := Viewport.Top;
         r.Bottom := r.Top + Viewport.Zoom;
         for y := 0 to (View.Height - 1) do begin
             if (r.Bottom >= 0) and (r.Top <= Cnv.Height) then begin // not visible checks
                if ViewMode = ModeCrossSection then begin
                   if View.Canvas[x,y].Depth = View.Foreground then
                      PalIdx := PalOfs + View.Canvas[x,y].Colour
                   else
                       PalIdx := TRANSPARENT;
                end else if View.Canvas[x,y].Colour = TRANSPARENT then // ModeFull or ModeEmpDepth
                    PalIdx := TRANSPARENT
                else
                    PalIdx := PalOfs + View.Canvas[x,y].Colour;
                with Cnv.Canvas do begin
                     Brush.Color := Palette[PalIdx];
                     if (ViewMode = ModeEmphasiseDepth) and
                        (View.Canvas[x,y].Depth = View.Foreground) then begin
                        if Viewport.Zoom = 1 then
                           Pixels[r.Left,r.Top] := Pen.Color
                        else
                            Rectangle(r.Left,r.Top,r.Right,r.Bottom)
                     end else
                         FillRect(r);
{$IFDEF DEBUG_NORMALS}
                     if (SpectrumMode = ModeNormals) then
                        if (PalIdx <> TRANSPARENT) then
                           if Viewport.Zoom > 10 then begin
                              Font.Color := Palette[PalIdx] shr 2;
                              TextOut(r.Left,r.Top,IntToStr(View.Canvas[x,y].Colour));
                           end;
{$ENDIF}
                end;
             end;
             Inc(r.Top,Viewport.Zoom);
             Inc(r.Bottom,Viewport.Zoom);
         end;
     end;

     // draw cursor, but not if drawing!
     if not isMouseLeftDown then begin
       View.getPhysicalCursorCoords(x,y);

       //set brush color, or else it will get the color of the bottom-right voxel
       Cnv.Canvas.Brush.Color:=Palette[TRANSPARENT];
       // horiz
       r.Left := Max(Viewport.Left,0);
       r.Right := Min(Viewport.Left + (View.Width * Viewport.Zoom), Cnv.Width);
       r.Top := (y * Viewport.Zoom) + Viewport.Top + (Viewport.Zoom div 2) - 1;
       r.Bottom := r.Top + 2;
       Cnv.Canvas.DrawFocusRect(r);
       // vert
       r.Top := Max(Viewport.Top,0);
       r.Bottom := Min(Viewport.Top + (View.Height * Viewport.Zoom), Cnv.Height);
       r.Left := (x * Viewport.Zoom) + Viewport.Left + (Viewport.Zoom div 2) - 1;
       r.Right := r.Left + 2;
       Cnv.Canvas.DrawFocusRect(r);
     end;
end;

procedure TFrmMain.PaintThumb(WndIndex: Integer);
var cnvThumb: TPaintBox;
    View: TVoxelView;
    cnv: TPaintBox;
    Viewport: TViewport;
    ScaleX, ScaleY: Real;
    i, j, x, y: Integer;
    r: TRect;
begin
     if not isEditable then Exit;
     View := ActiveSection.View[WndIndex];
     cnvThumb := cnvViewScroll[WndIndex];
     cnv := cnvView[WndIndex];
     Viewport := ActiveSection.Viewport[WndIndex];
     ScaleX := cnvThumb.Width / View.Width;
     ScaleY := cnvThumb.Height / View.Height;
     if (ScaleX > 1.0) or (ScaleY > 1.0) then begin
        r.Left := 0;
        r.Right := Ceil(ScaleX);
        for i := 0 to (View.Width - 1) do begin
            r.Left := Trunc(i * ScaleX);
            r.Right := Ceil((i + 1) * ScaleX);
            for j := 0 to (View.Height - 1) do begin
                r.Top := Trunc(j * ScaleY);
                r.Bottom := Ceil((j + 1) * ScaleY);
                with cnvThumb.Canvas do begin
                     Brush.Color := Palette[View.Canvas[i,j].Colour];
                     FillRect(r);
                end;
            end;
         end;
     end else begin
         for i := 0 to (View.Width - 1) do begin
             x := Round(i * ScaleX);
             for j := 0 to (View.Height - 1) do begin
                 y := Round(j * ScaleY);
                 cnvThumb.Canvas.Pixels[x,y] := Palette[View.Canvas[i,j].Colour];
             end;
         end;
     end;
     // show where the viewport is at the moment
     if (Viewport.Left > 0) and (Viewport.Top > 0) then Exit;
     if (Viewport.Left > 0) then begin
        r.Left := 0;
        r.Right := cnvThumb.Width;
     end else begin
         r.Left := Max(Trunc(Abs(Viewport.Left / Viewport.Zoom) * ScaleX),0);
         r.Right := Min(r.Left + Ceil((cnv.Width / Viewport.Zoom) * ScaleX),cnvThumb.Width);
     end;
     if (Viewport.Top > 0) then begin
        r.Top := 0;
        r.Bottom := cnvThumb.Height;
     end else begin
         r.Top := Max(Trunc(Abs(Viewport.Top / Viewport.Zoom) * ScaleY),0);
         r.Bottom := Min(r.Top + Ceil((cnv.Height / Viewport.Zoom) * ScaleY),cnvThumb.Height);
     end;
     cnvThumb.Canvas.DrawFocusRect(r);
end;

procedure TFrmMain.cnvView1Paint(Sender: TObject);
begin
     PaintView(1,cnvView1,ActiveSection.View[1]);
{    if pnlViewScroll1.Visible then
        pnlViewScroll1.Repaint;}
end;

procedure TFrmMain.cnvView2Paint(Sender: TObject);
begin
     PaintView(2,cnvView2,ActiveSection.View[2]);
{    if pnlViewScroll2.Visible then
        pnlViewScroll2.Repaint;}
end;

procedure TFrmMain.cnvView0Paint(Sender: TObject);
begin
     PaintView(0,CnvView0,ActiveSection.View[0]);
{     if pnlViewScroll0.Visible then
        pnlViewScroll0.Repaint;}
end;

procedure TFrmMain.FormKeyPress(Sender: TObject; var Key: Char);
var RepaintViews: Boolean;
begin
     // deal with historic keyboard accelerators
     RepaintViews := True; // assume so
     case Key of
          'X': ActiveSection.SetX(ActiveSection.X + 1);
          'Y': ActiveSection.SetY(ActiveSection.Y + 1);
          'Z': ActiveSection.SetZ(ActiveSection.Z + 1);
          'x': ActiveSection.SetX(ActiveSection.X - 1);
          'y': ActiveSection.SetY(ActiveSection.Y - 1);
          'z': ActiveSection.SetZ(ActiveSection.Z - 1);
     else
         RepaintViews := False;
     end;
     if RepaintViews then begin
        MajorRefresh;
        pnlX.Caption := IntToStr(ActiveSection.X);
        pnlY.Caption := IntToStr(ActiveSection.Y);
        pnlZ.Caption := IntToStr(ActiveSection.Z);
        Key := Chr(0);
     end;
end;

procedure TFrmMain.MajorRepaint; // repaints all views, even backgrounds
var i: Integer;
begin
     MajorRepaintFlag := True;
     for i := 0 to 2 do begin
         cnvView[i].Repaint;
         if isEditable then
            if ActiveSection.ThumbVisible[i] then
               cnvViewScroll[i].Repaint;
     end;
     cnvView[3].Repaint;
     MajorRepaintFlag := False;
end;

procedure TFrmMain.MajorRepaint(WndIndex: Integer); // repaints just this window, even background
begin
     MajorRepaintFlag := True;
     cnvView[WndIndex].Repaint;
     if ActiveSection.ThumbVisible[WndIndex] then
        cnvViewScroll[WndIndex].Repaint;
     MajorRepaintFlag := False;
end;

procedure TFrmMain.MinorRepaint; // repaints all views, but not backgrounds
var WndIndex: Integer;
begin
     for WndIndex := 0 to 2 do begin
         cnvView[WndIndex].Repaint;
         if ActiveSection.ThumbVisible[WndIndex] then
            cnvViewScroll[WndIndex].Repaint;
     end;
     cnvView[3].Repaint;
end;

procedure TFrmMain.MinorRepaint(WndIndex: Integer); // repaints all views, but not backgrounds
begin
     cnvView[WndIndex].Repaint;
     if ActiveSection.ThumbVisible[WndIndex] then
        cnvViewScroll[WndIndex].Repaint;
end;
procedure TFrmMain.splViewsMoved(Sender: TObject);
begin
     MajorRepaint;
end;

// Zoom to fit window
procedure TFrmMain.mnuZoomFitClick(Sender: TObject);
var comp: TComponent;
procedure ZoomFit(WndIndex: Integer);
begin
     ZoomToFit(WndIndex);
     CentreZoom(WndIndex);
     MajorRepaint(WndIndex);
end;
var i: Integer;
    KnownComponent: Boolean;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            ZoomFit(i);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "zoom to fit window" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.SetEditable(ok: Boolean);
var i: Integer;
begin
     isEditable := ok;
     for i := 0 to 2 do begin
         cnvView[i].Enabled := isEditable;
         lblView[i].Enabled := isEditable;
     end;
     mnuView.Enabled  := isEditable;
     mnuSection.Enabled := isEditable;
     mnuSaveAs.Enabled := isEditable;
     mnuModel.Enabled := isEditable;
     cboSections.Enabled := isEditable;
     butSectionEditHeader.Enabled := isEditable;
     sclView3X.Enabled := isEditable;
     sclView3Y.Enabled := isEditable;
     sclView3Z.Enabled := isEditable;
end;

procedure TFrmMain.mnuNewClick(Sender: TObject);
{$IFDEF PLASMA_PROJECT}
var
  frm: TFrmNewProject;
{$ENDIF}
  begin
{$IFDEF PLASMA_PROJECT}
  frm:=TFrmNewProject.Create(Self);
  frm.SetHVAMode(ToolButton5.Visible);
  frm.ShowModal;
  frm.Free;
{$ELSE}
  //the old way of new voxel.
  CreateNewVoxel('');
{$ENDIF}
end;

procedure TFrmMain.mnuRefreshViewClick(Sender: TObject);
var comp: TComponent;
procedure RefreshView(WndIndex: Integer);
begin
     ActiveSection.View[WndIndex].Refresh;
     MajorRepaint(WndIndex);
end;
var i: Integer;
    KnownComponent: Boolean;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            RefreshView(i);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "Repaint Window" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.mnuSelectColourClick(Sender: TObject);
var i: Integer;
    comp: TComponent;
    KnownComponent: Boolean;
    v: TVoxelUnpacked;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            ActiveSection.GetVoxel(LastClick[i].X,LastClick[i].Y,LastClick[i].Z,v);
            if v.Used then begin
               if SpectrumMode = ModeColours then
                  SetActiveColour(v.Colour)
               else // SpectrumMode = ModeNormals
                    SetActiveNormal(v.Normal);
            end else
                MessageDlg('Select Colour triggered despite no colour under the cursor!',mtError,[mbOK],0);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "Select Colour" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.mnuZoomInClick(Sender: TObject);
var comp: TComponent;
procedure ZoomIn(WndIndex: Integer);
var am: Integer; // amount to increment zoom by
begin
     with ActiveSection.Viewport[WndIndex] do begin
          if Zoom < 5 then
             am := 1
          else if Zoom < 10 then
               am := 2
          else
              am := 3;
          Zoom := Min(Zoom + am,30); // can't go higher than 30
     end;
     // should actually centre on point instead, but that can wait
     CentreZoom(WndIndex);
     MajorRepaint(WndIndex);
end;
var i: Integer;
    KnownComponent: Boolean;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            ZoomIn(i);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "Zoom In" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.mnuZoomOutClick(Sender: TObject);
var comp: TComponent;
procedure ZoomOut(WndIndex: Integer);
var am: Integer; // amount to decrement zoom by
begin
     with ActiveSection.Viewport[WndIndex] do begin
          if Zoom < 5 then
             am := 1
          else if Zoom < 10 then
               am := 2
          else
              am := 3;
          Zoom := Max(Zoom - am,1); // can't go higher lower than 1
     end;
     // should actually centre on point instead, but that can wait
     CentreZoom(WndIndex);
     MajorRepaint(WndIndex);
end;
var i: Integer;
    KnownComponent: Boolean;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            ZoomOut(i);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "Zoom In" from a "' + comp.ClassName + '"!');
end;

// a chance to enable / disable inappropriate options
procedure TFrmMain.mnuZoomPopupPopup(Sender: TObject);
var comp: TComponent;
procedure EnableZooms(WndIndex: Integer);
begin
     with ActiveSection.Viewport[WndIndex] do begin
          mnuZoomOut.Enabled := (Zoom > 1);
          mnuZoomIn.Enabled := (Zoom < 30);
          mnuZoomInfo.Caption := 'Zoom is 1:' + IntToStr(Zoom);
     end;
end;
var i, X, Y: Integer;
    KnownComponent: Boolean;
begin
     X:=0; Y:=0;  //this gets rid of the 2 compiler warnings
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            EnableZooms(i);
            mnuShowScroll.Checked := ActiveSection.ThumbVisible[i];
            with ActiveSection.View[i] do begin
                 case getOrient of
                      oriX: begin
                            X := LastClick[i].Y;
                            Y := LastClick[i].Z;
                            end;
                      oriY: begin
                            X := LastClick[i].X;
                            Y := LastClick[i].Z;
                            end;
                      oriZ: begin
                            X := LastClick[i].X;
                            Y := LastClick[i].Y;
                            end;
                 end;
                 mnuSelectColour.Enabled := Canvas[X,Y].Colour <> TRANSPARENT;
                 if SpectrumMode = ModeColours then
                    mnuSelectColour.Caption := 'Select colour at this point'
                 else // SpectrumMode = ModeNormals
                      mnuSelectColour.Caption := 'Select normal at this point';
            end;
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "Menu Popup" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.mnuRefreshScreenClick(Sender: TObject);
begin
     MajorRepaint;
end;

procedure TFrmMain.mnuZoomFitAllClick(Sender: TObject);
var WndIndex: Integer;
begin
     for WndIndex := 0 to 2 do begin
         ZoomToFit(WndIndex);
         CentreZoom(WndIndex);
     end;
     MajorRepaint;
end;

procedure TFrmMain.cboSectionsClick(Sender: TObject);
var i: Integer;
begin
     //before switching, reset the undo system
     UndoSystem.Clear;
     // change active view
     ActiveSection := Voxel.Section[cboSections.ItemIndex];
     //now save a dump of the current changs
     ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
     UpdateUndoStatus;
     SetNormalsPalette;
     for i := 0 to 2 do
         with ActiveSection.Viewport[i] do begin
              if not hasBeenUsed then begin
                 ZoomToFit(i);
                 CentreZoom(i);
                 hasBeenUsed := True;
              end;
         end;
     // update status bar
     pnlX.Caption := IntToStr(ActiveSection.X);
     pnlY.Caption := IntToStr(ActiveSection.Y);
     pnlZ.Caption := IntToStr(ActiveSection.Z);
     // set the 3D view
     View3D.Free;
     View3D := TVoxel3D.Create(ActiveSection);
     View3D.Render(sclView3X.Position,sclView3Y.Position,sclView3Z.Position);
     // and view names etc
     SyncViews;
     MajorRepaint;
end;


procedure TFrmMain.cnvPaletteMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
begin
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     i := Trunc(X / colwidth);
     j := Trunc(Y / rowheight);
     idx := (i * 32) + j;
     if SpectrumMode = ModeColours then
        SetActiveColour(idx)
     else
        SetActiveNormal(idx);
end;

procedure TFrmMain.ShowScroll(WndIndex: Integer; Toggle: Boolean);
var Viewport: TViewport;
    wasVisible: Boolean;
begin
     if not isEditable then Exit;
     Viewport := ActiveSection.Viewport[WndIndex];
     with ActiveSection do begin
          wasVisible := pnlViewScroll[WndIndex].Visible;
          if Toggle then
             ThumbVisible[WndIndex] := not ThumbVisible[WndIndex];
          if ThumbVisible[WndIndex] then begin
             with pnlViewScroll[WndIndex] do begin
                  Visible := False;
                  Left := cnvView[WndIndex].Left;
                  Top := cnvView[WndIndex].Top;
                  Width := Thumb[WndIndex].Width;
                  Height := Thumb[WndIndex].Height;
                  Visible := True;
             end;
          end else
              if wasVisible then begin
                 pnlViewScroll[WndIndex].Visible := False;
                 MajorRepaint(WndIndex);
              end;
     end;
end;

procedure TFrmMain.cnvViewScrollPaint(Sender: TObject);
begin
     if Sender = cnvViewScroll0 then
        PaintThumb(0)
     else if Sender = cnvViewScroll1 then
          PaintThumb(1)
     else if Sender = cnvViewScroll2 then
          PaintThumb(2);
end;

procedure TFrmMain.mnuShowScrollClick(Sender: TObject);
var i: Integer;
    comp: TComponent;
    KnownComponent: Boolean;
begin
     comp := mnuZoomPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = cnvView[i] then begin
            ShowScroll(i,True);
            if not ActiveSection.ThumbVisible[i] then
               MajorRepaint(i);
            KnownComponent := True;
            Break;
         end;
     end;
     if not KnownComponent then
         ShowMessage('Debug' + Chr(10) + 'Unexpected "MnuShowScroll" from a "' + comp.ClassName + '"!');
end;

procedure TFrmMain.mnuDirectionPopupPopup(Sender: TObject);
var comp: TComponent;
    idx: Integer;
    View: TVoxelView;
begin
     comp := mnuDirectionPopup.PopupComponent;
     mnuEdit.Visible := (comp <> lblView0); // can't edit as already editing it!
     if comp = lblView0 then
        View := ActiveSection.View[0]
     else if comp = lblView1 then
          View := ActiveSection.View[1]
     else
         View := ActiveSection.View[2];
     idx := (View.getViewNameIdx div 2) * 2;
     with mnuDirTowards do begin
          Caption := ViewName[idx];
          Enabled := not (View.getDir = dirTowards);
     end;
     with mnuDirAway do begin
          Caption := ViewName[idx+1];
          Enabled := not (View.getDir = dirAway);
     end;
end;

procedure TFrmMain.mnuEditClick(Sender: TObject);
var comp: TComponent;
begin
     comp := mnuDirectionPopup.PopupComponent;
     if comp = lblView1 then
        ActivateView(1)
     else
         ActivateView(2);
end;

procedure TFrmMain.mnuDirTowardsClick(Sender: TObject);
procedure SetDir(WndIndex: Integer);
var idx: Integer;
begin
     with ActiveSection.View[WndIndex] do begin
          setDir(dirTowards);
          idx := getViewNameIdx;
          lblView[WndIndex].Caption := ViewName[idx];
          Refresh;
          cnvView[WndIndex].Repaint;
     end;
end;
var i: Integer;
    KnownComponent: Boolean;
    comp: TComponent;
begin
     comp := mnuDirectionPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = lblView[i] then begin
            SetDir(i);
            KnownComponent := True;
            Break;
         end;
     end;
end;

procedure TFrmMain.mnuDirAwayClick(Sender: TObject);
procedure SetDir(WndIndex: Integer);
var idx: Integer;
    View: TVoxelView;
begin
     with ActiveSection.View[WndIndex] do begin
          setDir(dirAway);
          idx := getViewNameIdx;
          lblView[WndIndex].Caption := ViewName[idx];
          Refresh;
          cnvView[WndIndex].Repaint;
     end;
end;
var i: Integer;
    KnownComponent: Boolean;
    comp: TComponent;
begin
     comp := mnuDirectionPopup.PopupComponent;
     KnownComponent := False;
     for i := 0 to 2 do begin
         if comp = lblView[i] then begin
            SetDir(i);
            KnownComponent := True;
            Break;
         end;
     end;
end;

procedure TFrmMain.cnvViewScroll0MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     CentreZoom(0,X,Y);
end;

procedure TFrmMain.cnvViewScroll1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     CentreZoom(1,X,Y);
end;

procedure TFrmMain.cnvViewScroll2MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     CentreZoom(2,X,Y);
end;


procedure TFrmMain.FormResize(Sender: TObject);
var WndIndex: Integer;
begin
     for WndIndex := 0 to 2 do
         CentreZoom(WndIndex);
     MajorRepaint;
end;

procedure TFrmMain.mnuDrawModeClick(Sender: TObject);
begin
     mnuViewModeFull.Checked := (ViewMode = ModeFull);
     mnuViewModeCrossSection.Checked := (ViewMode = ModeCrossSection);
     mnuViewModeEmphasiseDepth.Checked := (ViewMode = ModeEmphasiseDepth);
end;

procedure TFrmMain.mnuViewModeFullClick(Sender: TObject);
begin
     ViewMode := ModeFull;
     MinorRepaint;
end;

procedure TFrmMain.mnuViewModeCrossSectionClick(Sender: TObject);
begin
     ViewMode := ModeCrossSection;
     MinorRepaint;
end;

procedure TFrmMain.mnuViewModeEmphasiseDepthClick(Sender: TObject);
begin
     ViewMode := ModeEmphasiseDepth;
     MinorRepaint;
end;

procedure TFrmMain.mnuSpectrumColoursClick(Sender: TObject);
var i: Integer;
begin
     SpectrumMode := ModeColours;
     lblPalette.Caption := ' Palette > Colours ';
     cnvPalette.Repaint;
     voxel.setSpectrum(SpectrumMode);
     MajorRefresh;
end;

procedure TFrmMain.mnuSpectrumNormalsClick(Sender: TObject);
var i: integer;
begin
     SpectrumMode := ModeNormals;
     lblPalette.Caption := ' Palette > Normals ';
     cnvPalette.Repaint;
     voxel.setSpectrum(SpectrumMode);
     MajorRefresh;
end;

procedure TFrmMain.mnuSpectrumClick(Sender: TObject);
begin
     mnuSpectrumColours.Checked := (SpectrumMode = ModeColours);
     mnuSpectrumNormals.Checked := (SpectrumMode = ModeNormals);
end;

procedure TFrmMain.butSectionEditHeaderClick(Sender: TObject);
var
  FrmHeader: TFrmHeader;
begin
  FrmHeader:=TFrmHeader.Create(Self);
  with FrmHeader do begin
    SetValues(@Voxel);
    ShowModal;
    Free;
  end;
end;

procedure TFrmMain.TranslateClick(WndIndex, sx, sy: Integer; var lx, ly, lz: Integer);
var
  p, q: Integer; // physical coords
begin
     //following code needs to be fixed/replaced
     with ActiveSection do begin
       //new conversion routines?
       p:=(sx - Viewport[WndIndex].Left) div Viewport[WndIndex].Zoom;
       q:=(sy - Viewport[WndIndex].Top) div Viewport[WndIndex].Zoom;
       p:=Max(p,0);  //make sure p is >=0
       q:=Max(q,0);  //same for q
       //also make sure they're in range of 0..(Width/Height/Depth)-1
       p:=Min(p,View[WndIndex].Width - 1);
       q:=Min(q,View[WndIndex].Height - 1);

       //px/py were from original version, but they give wrong values sometimes (because they use / and trunc instead of div)!
       //px := Min(Max(Trunc((sx - Viewport[WndIndex].Left) / Viewport[WndIndex].Zoom),0),View[WndIndex].Width - 1);
       //py := Min(Max(Ceil((sy - Viewport[WndIndex].Top) / Viewport[WndIndex].Zoom),0),View[WndIndex].Height - 1);

       View[WndIndex].TranslateClick(p,q,lx,ly,lz);
     end;
     //I want range checks - on lx,ly and lz
     //Range checks are already performed somewhere else, but where?!
     //They are flawed!
     //the only reason the program doesn't crash with X is because it can write in
     //other parts of the file!!!
     if not (lx in [0..ActiveSection.Tailer.XSize-1]) then ShowMessage('X range error');
     if not (ly in [0..ActiveSection.Tailer.YSize-1]) then ShowMessage('Y range error');
     if not (lz in [0..ActiveSection.Tailer.ZSize-1]) then ShowMessage('Z range error');
end;


procedure TFrmMain.MoveCursor(lx, ly, lz: Integer);
begin
     with ActiveSection do begin
          SetX(lx);
          SetY(ly);
          SetZ(lz);
     end;
     MajorRefresh;
end;

procedure TFrmMain.cnvView1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     TranslateClick(1,X,Y,LastClick[1].X,LastClick[1].Y,LastClick[1].Z);
     if Button = mbLeft then
        MoveCursor(LastClick[1].X,LastClick[1].Y,LastClick[1].Z);
end;

procedure TFrmMain.cnvView2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     TranslateClick(2,X,Y,LastClick[2].X,LastClick[2].Y,LastClick[2].Z);
     if Button = mbLeft then
        MoveCursor(LastClick[2].X,LastClick[2].Y,LastClick[2].Z);
end;

procedure TFrmMain.cnvView0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var v: TVoxelUnpacked;
    i: Integer;
begin
     // this function will get more complicated in the future!
     TranslateClick(0,X,Y,LastClick[0].X,LastClick[0].Y,LastClick[0].Z);
     // is this is a move-cursor command?
     if (Shift = [ssCtrl]) and (Button = mbLeft) then begin
        MoveCursor(LastClick[0].X,LastClick[0].Y,LastClick[0].Z);
        IsMouseLeftDown := False;
        Exit;
     end;
     // is this a paint command?
     if isMouseLeftDown then begin
        cnvView0MouseMove(Sender,Shift,X,Y);
        isMouseLeftDown := False;
        MajorRefresh;
     end;
end;

procedure TFrmMain.cnvView0MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var v: TVoxelUnpacked;
    i: Integer;
label exitC;
begin
     if isMouseLeftDown then begin // mouse drag?  Paint square
        if ssCtrl in Shift then Exit;
        // this function will get more complicated in the future!
        TranslateClick(0,X,Y,LastClick[0].X,LastClick[0].Y,LastClick[0].Z);
        edit1.Text := InttoStr(LastClick[0].X) + ' ' + InttoStr(LastClick[0].Y) + ' ' + InttoStr(LastClick[0].Z);{debug info}
        case DrawMode of
             ModeDraw: begin
                v.Colour := ActiveColour;
                v.Normal := ActiveNormal;
                v.Used := True;
                MajorRepaint;
                //I can't understand why there are no range checks here...
                ActiveSection.SetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
                ActiveSection.View[0].Refresh;
                MinorRepaint(0);
             end;

             ModeMagnify: Begin
                CentreZoom(MagnifyZoom);
             end;

             ModeColSelect: Begin
              ActiveSection.GetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
               if v.Used then begin
                 if SpectrumMode = ModeColours then
                   SetActiveColour(v.Colour)
                 else // SpectrumMode = ModeNormals
                   SetActiveNormal(v.Normal);
                 end else MessageDlg('Select Colour triggered despite no colour under the cursor!',mtError,[mbOK],0);

             end;

             ModeFloodFill: Begin
                v.Colour := ActiveColour;
                v.Normal := ActiveNormal;
                v.Used := True;
                MajorRepaint;
                ActiveSection.FloodFillTool(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v,ActiveSection.View[0].GetOrient);
                LastFloodPoint:=LastClick[0];
                ActiveSection.View[0].Refresh;
                MinorRepaint(0);
             end;

             ModeBrush: Begin
                v.Colour := ActiveColour;
                v.Normal := ActiveNormal;
                v.Used := True;
                MajorRepaint;
                //Rewrite by Koen
                ActiveSection.BrushTool(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v,BrushMode,ActiveSection.View[0].GetOrient);
                ActiveSection.View[0].Refresh;
                MinorRepaint(0);
             end;

             ModeRect: begin
                v.Colour := ActiveColour;
                v.Normal := ActiveNormal;
                v.Used := True;
                MajorRepaint;
                if ClickCount = 0 then begin
                  RectPoint:=LastClick[0];
                  ActiveSection.SetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
                  ActiveSection.View[0].refresh;
                 end;
                if ClickCount = 1 then begin
                  //ActiveSection.SetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
                  ActiveSection.Rectangle(RectPoint.X,RectPoint.Y,RectPoint.Z,LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v,False);
                 end;
             end;
             ModeRectFill: begin
                v.Colour := ActiveColour;
                v.Normal := ActiveNormal;
                v.Used := True;
                MajorRepaint;
                if ClickCount = 0 then begin
                  RectPoint:=LastClick[0];
                  ActiveSection.SetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
                  ActiveSection.View[0].refresh;
                 end;
                if ClickCount = 1 then begin
                  ActiveSection.Rectangle(RectPoint.X,RectPoint.Y,RectPoint.Z,LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v,True);
                 end;
             //---wait 2 hours
             end;
             ModeErase: begin
                v.Used := False;
                ActiveSection.SetVoxel(LastClick[0].X,LastClick[0].Y,LastClick[0].Z,v);
                ActiveSection.View[0].Refresh;
                MinorRepaint(0);
             end;
        end;
     end;
end;

procedure TFrmMain.cnvView0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if (Button = mbLeft) then begin
        isMouseLeftDown := True;
        cnvView0MouseMove(Sender,Shift,X,Y); // do paint etc?
     end;
end;

procedure TFrmMain.mnuSectionRemoveRedundantVoxelsClick(Sender: TObject);
var no, i: integer;
label Done;
begin
     // ensure the user wants to do this!
     if MessageDlg(
        'This process will alter your model!' + Chr(10) +
        'It will remove voxels that are inside the model, and are therefore hidden.' + Chr(10) +
        'This cannot be undone.  If you choose to do this, you should first save' + Chr(10) +
        'your model under a different name as a backup.',
        mtWarning,mbOKCancel,0) = mrCancel then goto Done;
     // stop undos
     UndoSystem.Clear;
     UpdateUndoStatus;
     // ok, do it
     ShowBusyMessage('Removing redundant voxels ...');
     no := RemoveRedundantVoxels(ActiveSection);
     HideBusyMessage;
     if no = 0 then
        ShowMessage('There are no redundant voxels to remove in this section')
     else begin
          ShowMessage(IntToStr(no) + ' redundant voxels removed');
          MajorRefresh;
     end;
Done:
     MajorRepaint;
end;

procedure TFrmMain.mnuSaveAsClick(Sender: TObject);
begin
     // prepare save path etc
     dlgSaveAs.Title := 'Save As';
     dlgSaveAs.Filename := ExtractFileName(dlgOpen.Filename);
     dlgSaveAs.InitialDir := ExtractFilePath(dlgOpen.Filename);
     // get the file to save to
     if dlgSaveAs.Execute then begin
        Clicked := false;
        ShowBusyMessage('Saving ...');
        FrmMain.Caption := 'Voxel Editor II - ' + ExtractFileName(dlgSaveAs.Filename);
        // save it
        voxel.SaveToFile(dlgSaveAs.Filename);
        File2Save := dlgSaveAs.Filename;
        Config.AddFileToHistory(dlgSaveAs.FileName);
        UpdateHistoryMenu;
        //--- saving to INI file last opened voxel file name ----
     //!hard
      {       try
               INI := TINIFile.Create('c:\windows\Vxlse.ini');
               INI.WriteString('LastOpened', '01' ,dlgSaveAs.Filename);
                finally
                 INI.Free;
             end;}
        //--------------------------------------------------------
        HideBusyMessage;
        if (voxel.ErrorCode <> OK) then begin
           ShowMessage('Could not save ''' + dlgSaveAs.Filename + '''');
           SetEditable(False); // just in case
        end;
        // so that next save-as works
        dlgOpen.Filename := ExtractFileName(dlgSaveAs.Filename);
        dlgOpen.InitialDir := ExtractFilePath(dlgSaveAs.Filename);
        pnlOpenFile.Caption := dlgSaveAs.Filename;

     end;
end;

procedure TFrmMain.ShowBusyMessage(Msg: string);
begin
     // centre message
     pnlBusyMsg.Left := (cnvView0.Width - pnlBusyMsg.Width) div 2;
     pnlBusyMsg.Top := (cnvView0.Height - pnlBusyMsg.Height) div 2;
     // show it
     lblBusyMsg.Caption := Msg;
     pnlBusyMsg.Visible := True;
     pnlBusyMsg.Repaint; // force show
end;

procedure TFrmMain.HideBusyMessage;
begin
     pnlBusyMsg.Visible := False;
end;

procedure TFrmMain.cnvView3Paint(Sender: TObject);
var x, y: integer;
begin
     if View3D = nil then Exit; // safety check
     with View3D do

          for x := 0 to (Width - 1) do
              for y := 0 to (Height - 1) do
                  cnvView3.Canvas.Pixels[x,y] := Palette[Canvas[x,y].Colour];
end;

procedure TFrmMain.MoveView3D(Sender: TObject);
begin
     if View3D = nil then Exit;
     View3D.Render(sclView3X.Position,sclView3Y.Position,sclView3Z.Position);
     cnvView3.Repaint;
end;

procedure TFrmMain.RefreshAll;
begin
 MinorRepaint(0);
 MajorRepaint;
 MajorRefresh;

end;

procedure TFrmMain.MajorRefresh;
var WndIndex: integer;
begin
     // refresh the actual views
     with ActiveSection do
          for WndIndex := 0 to 2 do
              View[WndIndex].Refresh;
     View3D.Render(sclView3X.Position,sclView3Y.Position,sclView3Z.Position);
     // and redraw then
     MinorRepaint;
     cnvView3.Repaint;
end;

procedure TFrmMain.btnPaintClick(Sender: TObject);
begin
HideToolPanels;
     DrawMode := ModeDraw;
end;

procedure TFrmMain.btnEraseClick(Sender: TObject);
begin
     HideToolPanels;
     DrawMode := ModeErase;
end;

procedure TFrmMain.mnuSectionClearClick(Sender: TObject);
begin
  if mnuModel.Enabled = true then  begin
    if MessageDlg('This will remove all voxels from this model- are you sure?',
      mtWarning,[mbNo,mbYes],0) = mrYes then begin
      Clicked:=True;
      ActiveSection.Clear;
      MajorRefresh;
      ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
      UpdateUndoStatus;
    end;
  end else begin
    MessageDlg('Open a file first',mtInformation,[mbOK],0);
  end;
end;

procedure TFrmMain.mnuSectionResizeClick(Sender: TObject);
var
  FrmNew: TFrmNew;
begin
if mnuModel.Enabled = true then begin
  FrmNew:=TFrmNew.Create(Self);
     with FrmNew do begin
      FrmNew.Caption := ' Resize';
      grpCurrentSize.Left := 8;
      grpNewSize.Left := 112;
      grpNewSize.Width := 97;
      grpCurrentSize.Visible := true;

          x := ActiveSection.Tailer.XSize;
          y := ActiveSection.Tailer.YSize;
          z := ActiveSection.Tailer.ZSize;
          ShowModal;
          if changed then begin
             //Save undo information
             ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
             SetEditable(false);
             ActiveSection.Resize(x,y,z);
             SetEditable(true);
             cboSectionsClick(Sender);
          end;
     end;
  FrmNew.Free;
 end
 else MessageDlg('Open a file first',mtInformation,[mbOK],0);
end;

procedure TFrmMain.mnuSectionNewSectionClick(Sender: TObject);
var
  S: string;
  i, SectionIndex: Integer;
  FrmNewSectionSize: TFrmNewSectionSize;
begin
  FrmNewSectionSize:=TFrmNewSectionSize.Create(Self);
  with FrmNewSectionSize do begin
          ShowModal;
          if aborted then Exit;
          if before then s := 'before' else s := 'after';
          if MessageDlg('Are you sure you want to create a section: ' + Chr(10) +
             'Name: ' + AsciizToStr(Name,16) + Chr(10) +
             'Size: ' + IntToStr(X) + 'x' + IntToStr(Y) + 'x' + IntToStr(Z) + Chr(10) +
             s + ' this section',
             mtConfirmation,[mbYes,mbNo],0) = mrYes then
           SetEditable(False);
           //beta... completely untested. But hey - what do you want?

           SectionIndex:=ActiveSection.Header.Number;
           if not before then //after
             Inc(SectionIndex);

  //This isn't finished yet, but this action, if supported, cannot be undone (because we're switching section)
  UndoSystem.Clear;
           Voxel.InsertSection(SectionIndex,Name,X,Y,Z);

           cboSections.Items.Clear;
           for i:=0 to Voxel.Header.NumSections-1 do begin
             cboSections.Items.Add(Voxel.Section[i].Name);
           end;
           SyncViews;
           ShowScroll(0,False);
           ShowScroll(1,False);
           ShowScroll(2,False);
           SetEditable(True);
           mnuZoomFitAllClick(Self);
           MajorRepaint;
           cboSections.ItemIndex:=SectionIndex;
           cboSectionsClick(Self);
  end;
  FrmNewSectionSize.Free;
end;

procedure TFrmMain.mnuModelHVAClick(Sender: TObject);
type
 THVA = procedure(FileName: PChar);
var
  DLLI : THandle;
  HVA: THVA;
begin
if mnuModel.Enabled = true then begin
  OpenAFile(''); //ask for save changes first!
  DLLI := LoadLibrary('Plug_HVA.dll'); //load library
  if DLLI = 0 then //just for case
  begin
    Exit;
  end;
  @HVA := GetProcAddress(DLLI, 'VXLSE_Link_HVA');
  if @HVA <> nil then begin
    HVA(PChar(ChangeFileExt(File2Save,'.hva')));
  end else
    ShowMessage('ERROR: Cannot find correct DLL library!');
  FreeLibrary(DLLI);
end else MessageDlg('Open a file first',mtInformation,[mbOK],0);
end;

procedure TFrmMain.Showpositiondebug1Click(Sender: TObject);
begin
 ZZPanel.Left := cnvView0.Width - 65;
if ZZPanel.Visible = false then
 ZZPanel.Visible := true else
 ZZPanel.Visible := false;
end;

procedure TFrmMain.Close1Click(Sender: TObject);
begin
 ZZPanel.Visible := false;
end;

procedure TFrmMain.willClick(Sender: TObject);
begin
  OpenHyperLink('http://will.mojosys.org/');
end;

procedure TFrmMain.OlafvanderSpek1Click(Sender: TObject);
begin
  OpenHyperLink('http://xcc.virtualgn.com/');
end;

procedure TFrmMain.Plasmadroidforupdates1Click(Sender: TObject);
begin
  OpenHyperLink('http://plasmadroid.republika.pl/');
end;

procedure TFrmMain.Ra2ForumPL1Click(Sender: TObject);
begin
  OpenHyperLink('http://ra2.polbox.pl/');
end;

procedure TFrmMain.BGCNC1Click(Sender: TObject);
begin
  OpenHyperLink('http://www.bgcnc.com/');
end;

procedure TFrmMain.BarReopenClick(Sender: TObject);
begin
 mnuBarReopen.Caption := Config.GetHistory(0);
end;

procedure TFrmMain.mnuBarReopenClick(Sender: TObject);
begin
 Toolbar1.Visible := false;
end;

procedure TFrmMain.ShowMenuBar1Click(Sender: TObject);
begin
 toolbar1.Visible := true;
end;

procedure TFrmMain.ToolButton3Click(Sender: TObject);
begin
  mnuSectionClear.Click;
end;

procedure TFrmMain.cnvView0Click(Sender: TObject);
begin
  HideToolPanels;
  //save undo info after changing
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  //After-save
  Clicked := true;


  if (DrawMode = ModeRectFill) or (DrawMode = ModeRect) then begin
    if ClickCount = 0 then begin
      Clickcount := 1;
    end else if ClickCount = 1 then begin
      Clickcount := 0;
    end;
  end;
end;

procedure TFrmMain.mnuSaveClick(Sender: TObject);
begin
  Clicked := false;
  if File2Save <> 'unnamed.vxl' then begin
    if FileExists(File2Save) then begin
      ShowBusyMessage('Saving...');
      Voxel.SaveToFile(File2Save);
      HideBusyMessage;
    end;
  end;
  if File2Save = 'unnamed.vxl' then begin
    mnuSaveAs.Click;
  end;
end;

procedure TFrmMain.mnuUndoClick(Sender: TObject);
begin
  if UndoSystem.UndoLeft then begin
//    ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
    ActiveSection.LoadUndoDump(UndoSystem.GetUndoPointer^);
    MajorRefresh;
  end;
  UpdateUndoStatus;
end;

procedure TFrmMain.mnuRedoClick(Sender: TObject);
begin
  if UndoSystem.RedoLeft then begin
    ActiveSection.LoadUndoDump(UndoSystem.GetRedoPointer^);
    MajorRefresh;
  end;
  UpdateUndoStatus;
end;

procedure TFrmMain.btnRectClick(Sender: TObject);
begin
  HideToolPanels;
  DrawMode := ModeRect;
  pnlRect.Visible := true;
  ClickCount:=0; //to avoid problems, reset the clickcount
end;

procedure TFrmMain.LoadPrmFileClick(Sender: TObject);
begin
//Use OpenAFile code instead of this, it does exactly the same :)

  if FileExists(ParamStr(1)) then begin
    OpenAFile(ParamStr(1));
  end;

end;

procedure TFrmMain.notClickedClick(Sender: TObject);
begin
 clicked := false;
end;

procedure TFrmMain.Zoom2fitClick(Sender: TObject);
begin
 //*--zoom to fit all--*//
  mnuZoomFitAll.click;
//*-------------------*//
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
begin
  //confirm 'save changes first'
  OpenAFile('');

{ If fileexists('c:\data2.bak') then begin
  DeleteFile('c:\data2.bak');
  end;
 If fileexists('c:\data.bak') then begin
  DeleteFile('c:\data.bak');
  end;}
  for i:=0 to HistoryDepth - 1 do begin
    mnuHistory[i].Free;
  end;
  Config.SaveSettings;
  Config.Free;
  UndoSystem.Clear;
  UndoSystem.Free;
  Action:=caFree;
end;


procedure TFrmMain.mnuOptionsClick(Sender: TObject);
var
  OptionsFrm: TOptionsFrm;
begin
  OptionsFrm:=TOptionsFrm.Create(Self);
  OptionsFrm.GetSettings;
  OptionsFrm.ShowModal;
  OptionsFrm.Free;
end;

procedure TFrmMain.PlanetCNC1Click(Sender: TObject);
begin
  OpenHyperLink('http://www.planetcnc.com/');
end;

procedure TFrmMain.Ra2ModMakers1Click(Sender: TObject);
begin
  OpenHyperLink('http://www.planetcnc.com/ra2mod/');
end;

procedure TFrmMain.TibEdNetforpluginupdates1Click(Sender: TObject);
begin
  OpenHyperLink('http://www.tibed.net/voxel/');
end;

procedure TFrmMain.UpdateHistoryMenu;
var
  i: Integer;
  S: String;
begin
  //update the history menu (recently used file menu, whatever it's called)
  for i:=0 to HistoryDepth - 1 do begin
    S:=Config.GetHistory(i);
    mnuHistory[i].Tag:=i;
    if S='' then mnuHistory[i].Visible:=False else mnuHistory[i].Visible:=True;
    if i<9 then
      mnuHistory[i].Caption:='&'+IntToStr(i+1)+' '+S
    else if i=9 then
      mnuHistory[i].Caption:='&0 '+S
    else
      mnuHistory[i].Caption:='&'+Chr(55+i)+' '+S;
  end;
end;

procedure TFrmMain.mnuHistoryClick(Sender: TObject);
var
  p: ^TMenuItem;
begin
  if Sender.ClassNameIs('TMenuItem') then begin //check to see if it is this class
    //and now do some dirty things with pointers...
    p:=@Sender;
    OpenAFile(Config.GetHistory(p^.Tag));
  end;
end;

procedure TFrmMain.OpenAFile(FileName: String; FriendlyName: String='');
begin
  if Clicked = true then begin
    if MessageDlg('Last changes not saved. Save changes in ' + ExtractFileName(File2Save) +' ?',mtWarning,[mbYes,mbNo],0) = mrYes then begin
      mnuSave.Click;
      Clicked:=False;
    end;
  end;

  if FileName='' then Exit;

  if FileExists(FileName) then begin
    if FriendlyName='' then
      FrmMain.Caption := 'Voxel Editor II - ' + ExtractFileName(FileName)
    else
      FrmMain.Caption := 'Voxel Editor II - ' + FriendlyName;
//    t1:=Now;
    File2Save := FileName;
    File2SaveFriendly:=FriendlyName;
    OpenVoxelFile(FileName);
//    t2:=Now;
//    ShowMessage(FloatToStr((t2-t1)*24*3600));
{    t1:=Now;
    voxel.SaveToFile('C:\data2.bak');
    voxel.SaveToFile('C:\data.bak');
    t2:=Now;}
//    ShowMessage(FloatToStr((t2-t1)*24*3600));
{$IFNDEF TIB_PLUGIN}
    Config.AddFileToHistory(FileName);
    UpdateHistoryMenu;
{$ENDIF}
    mnuSave.Enabled := true;
    BarSaveAs.Enabled := true;
    //we didn't make any changes to this file, right?
    Clicked:=False;
  end else begin
    MessageDlg('File does not exists!',mtWarning,[mbOK],0);
  end;
end;

procedure TFrmMain.mnuAboutClick(Sender: TObject);
var
  frm: TLoadFrm;
begin
  frm:=TLoadFrm.Create(Self);
  frm.Visible:=False;
  frm.butOK.Visible:=True;
  frm.Loading.Caption:='';
  frm.ShowModal;
  frm.Close;
  frm.Free;
end;

procedure TFrmMain.FormShow(Sender: TObject);
var
  frm: TLoadFrm;
  l: Integer;
begin
  //Show the waiting screen?
  frm:=TLoadFrm.Create(Self);
  frm.Show;
  l := 0;
  while l < 45 do begin
    if l = 0 then begin frm.Loading.Caption := 'Please wait. Loading' end;
    if l = 10 then begin frm.Loading.Caption := 'Please wait. Loading.' end;
    if l = 20 then begin frm.Loading.Caption := 'Please wait. Loading..' end;
    if l = 30 then begin frm.Loading.Caption := 'Please wait. Loading...' end;
    if l = 43 then begin frm.Loading.Left := 120; frm.Loading.Caption := 'Everythink OK' end;
    l := l + 1;
    delay(30);
  end;
  frm.Close;
  frm.Free;
//  Zoom2fit.Click;
  mnuZoomFitAllClick(Self);
  Refresh;
end;

procedure TFrmMain.OpenHyperlink(HyperLink: PChar);
begin
  ShellExecute(Application.Handle,nil,HyperLink,'','',SW_SHOWNORMAL);
end;

procedure TFrmMain.UpdateUndoStatus;
begin
  mnuUndo.Enabled := UndoSystem.UndoLeft;
  mnuBarUndo.Enabled := UndoSystem.UndoLeft;
  mnuRedo.Enabled:=UndoSystem.RedoLeft;
  mnuBarRedo.Enabled:=UndoSystem.RedoLeft;
end;

procedure TFrmMain.mnuFlipXClick(Sender: TObject);
begin
  //Create a transformation matrix...
  ActiveSection.FlipMatrix([-1,1,1],[1,0,0]);
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  MajorRepaint;
  ActiveSection.View[0].Refresh;
  MinorRepaint(0);
  Clicked:=True;
end;

procedure TFrmMain.mnuFlipYClick(Sender: TObject);
begin
  //Create a transformation matrix...
  ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  MajorRepaint;
  ActiveSection.View[0].Refresh;
  MinorRepaint(0);
  Clicked:=True;
end;

procedure TFrmMain.mnuFlipZClick(Sender: TObject);
begin
  //Create a transformation matrix...
  ActiveSection.FlipMatrix([1,1,-1],[0,0,1]);
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  MajorRepaint;
  ActiveSection.View[0].Refresh;
  MinorRepaint(0);
  Clicked:=True;
end;

procedure TFrmMain.mnuMirrorHoriz1Click(Sender: TObject);
var
  FlipFirst: Boolean;
begin
  FlipFirst:=False;
  if (Sender.ClassNameIs('TMenuItem')) then begin
    if CompareStr((Sender as TMenuItem).Name,'mnuMirrorHoriz2')=0 then begin
      //flip first!
      FlipFirst:=True;
    end;
  end;
  //Based on the current view...
  case ActiveSection.View[0].GetViewNameIdx of
    0:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,1,-1],[0,0,1]);
      ActiveSection.Mirror(oriZ);
    end;
    1:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,1,-1],[0,0,1]);
      ActiveSection.Mirror(oriZ);
    end;
    2:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,1,-1],[0,0,1]);
      ActiveSection.Mirror(oriZ);
    end;
    3:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,1,-1],[0,0,1]);
      ActiveSection.Mirror(oriZ);
    end;
    4:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
      ActiveSection.Mirror(oriY);
    end;
    5:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
      ActiveSection.Mirror(oriY);
    end;
  end;
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  Clicked:=True;

  MajorRefresh;
end;

procedure TFrmMain.mnuMirrorVert1Click(Sender: TObject);
var
  FlipFirst: Boolean;
begin
  FlipFirst:=False;
  if (Sender.ClassNameIs('TMenuItem')) then begin
    if CompareStr((Sender as TMenuItem).Name,'mnuMirrorVert2')=0 then begin
      //flip first!
      FlipFirst:=True;
//      ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
    end;
  end;
  //Based on the current view...
  case ActiveSection.View[0].GetViewNameIdx of
    0:
    begin
      if FlipFirst then ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
      ActiveSection.Mirror(oriY);
    end;
    1:
    begin
      //reverse here :) (reversed view, that's why!)
      if not FlipFirst then ActiveSection.FlipMatrix([1,-1,1],[0,1,0]);
      ActiveSection.Mirror(oriY);
    end;
    2:
    begin
      if FlipFirst then ActiveSection.FlipMatrix([-1,1,1],[1,0,0]);
      ActiveSection.Mirror(oriX);
    end;
    3:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([-1,1,1],[1,0,0]);
      ActiveSection.Mirror(oriX);
    end;
    4:
    begin
      if FlipFirst then ActiveSection.FlipMatrix([-1,1,1],[1,0,0]);
      ActiveSection.Mirror(oriX);
    end;
    5:
    begin
      if not FlipFirst then ActiveSection.FlipMatrix([-1,1,1],[1,0,0]);
      ActiveSection.Mirror(oriX);
    end;
  end;
  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  Clicked:=True;

  MajorRefresh;
end;

procedure TFrmMain.mnuNudge1Click(Sender: TObject);
var
  i: Integer;
  NR: Array[0..2] of Single;
begin
  NR[0]:=0; NR[1]:=0; NR[2]:=0;
  if (Sender.ClassNameIs('TMenuItem')) then begin
    if (CompareStr((Sender as TMenuItem).Name,'mnuNudge1')=0) or (CompareStr((Sender as TMenuItem).Name,'mnuNudge2')=0) then begin
    //left and right
      case ActiveSection.View[0].GetViewNameIdx of
        0: NR[1]:=-1;
        1: NR[1]:=1;
        2: NR[0]:=-1;
        3: NR[0]:=1;
        4: NR[0]:=-1;
        5: NR[0]:=1;
      end;
      if CompareStr((Sender as TMenuItem).Name,'mnuNudge2')=0 then begin
        for i:=0 to 2 do begin
          NR[i]:=-NR[i];
        end;
      end;
    end else begin
      //up and down
      case ActiveSection.View[0].GetViewNameIdx of
        0: NR[2]:=-1;
        1: NR[2]:=-1;
        2: NR[2]:=-1;
        3: NR[2]:=-1;
        4: NR[1]:=-1;
        5: NR[1]:=-1;
      end;
      if CompareStr((Sender as TMenuItem).Name,'mnuNudge3')=0 then begin
        for i:=0 to 2 do begin
          NR[i]:=-NR[i];
        end;
      end;
    end;
  end;
  //another operation which is based on the current view
//  case ActiveSection.View[0].GetViewNameIdx of
  ActiveSection.FlipMatrix([1,1,1],NR,False);

  ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
  UpdateUndoStatus;
  Clicked:=True;

  MajorRefresh;
end;

procedure TFrmMain.mnuSectionDeleteClick(Sender: TObject);
var
  c: Word;
  SectionIndex,i: Integer;
begin
  if Voxel.Header.NumSections<2 then begin
    MessageDlg('Can''t delete if there''s only 1 section!',mtWarning,[mbOK],0);
    Exit;
  end;
  c:=MessageDlg('Are you sure you want to *delete* this section? This action can *not* be undone!!!',mtConfirmation,[mbYes,mbNo],0);
  if c=mrYes then begin
    //we can't undo these actions!!!
    UndoSystem.Clear;
    SetEditable(False);
    //beta... completely untested. But hey - what do you want?
    SectionIndex:=ActiveSection.Header.Number;
    Voxel.RemoveSection(SectionIndex);

    cboSections.Items.Clear;
    for i:=0 to Voxel.Header.NumSections-1 do begin
      cboSections.Items.Add(Voxel.Section[i].Name);
    end;
    SyncViews;
    ShowScroll(0,False);
    ShowScroll(1,False);
    ShowScroll(2,False);
    SetEditable(True);
    mnuZoomFitAllClick(Self);
    MajorRepaint;
    cboSections.ItemIndex:=0;
    cboSectionsClick(Self);
  end;
end;

procedure TFrmMain.mnuSectionResizeContentClick(Sender: TObject);
var
  frm: TFrmFullResize;
begin
  frm:=TFrmFullResize.Create(Self);
  with frm do begin
    x := ActiveSection.Tailer.XSize;
    y := ActiveSection.Tailer.YSize;
    z := ActiveSection.Tailer.ZSize;
    ShowModal;
    if Changed then begin
      //this won't help - because it will be cleared in cboSectionsClick
      SetEditable(false);
      ActiveSection.ResizeBlowUp(Scale);
      SetEditable(true);
      cboSectionsClick(Sender);
      MajorRefresh;
      ActiveSection.SaveUndoDump(UndoSystem.GetNewActionPointer^);
      UpdateUndoStatus;
    end;
  end;
  frm.Free;
end;

procedure TFrmMain.zoomInClick(Sender: TObject);
begin
if cnvView0.Height div 4 > pnlViewScroll0.Height then begin
pnlViewScroll0.Height := pnlViewScroll0.Height * 2;
pnlViewScroll0.Width := pnlViewScroll0.Width * 2;
end
else begin zoomin.Enabled := false; end;
end;

procedure TFrmMain.zoomOutClick(Sender: TObject);
begin
pnlViewScroll0.Height := pnlViewScroll0.Height div 2;
pnlViewScroll0.Width := pnlViewScroll0.Width div 2;
zoomin.Enabled := true;
end;

procedure TFrmMain.btnRect1Click(Sender: TObject);
begin
  DrawMode := ModeRect;
  pnlRect.visible := false;
  btnRect.Glyph := btnRect1.Glyph;
  btnRect2.Down:=False; btnRect1.Down:=True;
end;

procedure TFrmMain.btnRect2Click(Sender: TObject);
begin
  DrawMode := ModeRectFill;
  pnlRect.visible := false;
  btnRect.Glyph := btnRect2.Glyph;
  btnRect1.Down:=False; btnRect2.Down:=True;
end;


procedure TFrmMain.AboutHVAPluginClick(Sender: TObject);
type
  TAboutDialog = procedure; //const declaration...
var
  DLLI : THandle;
  AboutDialog : TAboutDialog;
begin
  DLLI := LoadLibrary('Plug_HVA.dll'); //load library
  if DLLI = 0 then //just for case
  begin
    MessageDlg(
    'ERROR: Cannot load DLL library!'+ chr(13) + 'Plug_HVA.dll',mtError,[mbOK],0);
    Exit;
  end;
  @AboutDialog := GetProcAddress(DLLI, 'AboutDialog');
  if @AboutDialog <> nil then begin AboutDialog;
  end
  else
  ShowMessage('ERROR: Cannot find correct DLL library!');
  FreeLibrary(DLLI); //unload library
end;


procedure TFrmMain.FormActivate(Sender: TObject);
type
  TAboutDialog = procedure; //const declaration...
  TVXLSE_Link_HVA = procedure (FName: PChar);
var
  DLLI : THandle;
  AboutDialog : TAboutDialog;
  HV: TVXLSE_Link_HVA;
begin
  DLLI := LoadLibrary('Plug_HVA.dll'); //load library
  if DLLI = 0 then //just for case
  begin
    mnuModelHVA.Enabled := false;
    ToolButton5.Enabled := false;
    Exit;
  end;
  @AboutDialog := GetProcAddress(DLLI, 'AboutDialog');
  if @AboutDialog <> nil then begin
    AboutHVAPlugin.Visible := true;
  end;
  @HV:=GetProcAddress(DLLI,'VXLSE_Link_HVA');
  if @HV <> nil then begin
    mnuModelHVA.Enabled := True;
    ToolButton5.Enabled := True;
  end else begin
    mnuModelHVA.Enabled := false;
    ToolButton5.Enabled := false;
  end;
  FreeLibrary(DLLI); //unload library
end;

procedure TFrmMain.btnZoomClick(Sender: TObject);
begin
  HideToolPanels;
  ShowMessage('Not supported yet!');
end;

procedure TFrmMain.btnLineClick(Sender: TObject);
begin
  HideToolPanels;
  // DrawMode := ModeLine;
  ShowMessage('Not supported yet!');
end;

procedure TFrmMain.SpeedButton3Click(Sender: TObject);
begin
  HideToolPanels;
  DrawMode := ModeBrush;
  BrushMode := 0;
  pnlBrush.Visible := true;
end;

procedure TFrmMain.SpeedButton4Click(Sender: TObject);
begin
  HideToolPanels;
  DrawMode := ModeColSelect;
end;

procedure TFrmMain.BtnFillClick(Sender: TObject);
begin
  HideToolPanels;
  DrawMode := ModeFloodFill;
end;

procedure TFrmMain.BtnZoom2xClick(Sender: TObject);
begin
magnifyZoom := 2;
pnlZoom.Visible := false;
end;

procedure TFrmMain.BtnZoom1xClick(Sender: TObject);
begin
{mnuZoomFit.Click;}
magnifyzoom := 0;
pnlZoom.Visible := false;

end;

procedure TFrmMain.BtnZoom4xClick(Sender: TObject);
begin
MagnifyZoom := 4;
pnlZoom.Visible := false;
end;

procedure TFrmMain.btnBrush1Click(Sender: TObject);
begin
DrawMode := ModeBrush;
BrushMode := 0;
pnlBrush.Visible := false;
btnBrush1.Down:=True;
end;

procedure TFrmMain.btnBrush2Click(Sender: TObject);
begin
DrawMode := ModeBrush;
BrushMode := 1;
pnlBrush.Visible := false;
btnBrush2.Down:=True;
end;

procedure TFrmMain.btnBrush3Click(Sender: TObject);
begin
DrawMode := ModeBrush;
BrushMode := 2;
pnlBrush.Visible := false;
btnBrush3.Down:=True;
end;

procedure TFrmMain.btnBrush4Click(Sender: TObject);
begin
DrawMode := ModeBrush;
BrushMode := 3;
pnlBrush.Visible := false;
btnBrush4.Down:=True;
end;

procedure TFrmMain.BtnFloodAClick(Sender: TObject);
begin
 HideToolPanels;
 DrawMode := ModeFloodFill;
 FloodMode := 0;
end;

procedure TFrmMain.BtnFloodBClick(Sender: TObject);
begin
 HideToolPanels;
 DrawMode := ModeFloodFill;
 FloodMode := 1;
end;

procedure TFrmMain.BtnFloodCClick(Sender: TObject);
begin
 HideToolPanels;
 DrawMode := ModeFloodFill;
 FloodMode := 2;
end;

procedure TFrmMain.HideToolPanels;
begin
 pnlRect.Visible := false;
 pnlBrush.Visible := false;
 pnlZoom.Visible := false;
end;

procedure TFrmMain.cnvPaletteClick(Sender: TObject);
begin
  HideToolPanels;
end;

procedure TFrmMain.LoadNormalsSchemesMenu;
var     item: TMenuItem;
        i: Integer;
begin
        for i := 0 to Pred(Length(NormalsSchemes)) do begin
                item := TMenuItem.Create(Owner);
                item.Caption := NormalsSchemes[i].FName;
                item.Tag := i; // so we know which it is
                item.OnClick := mnuSectionAutonormalsApply;
                mnuSectionAutonormals.Insert(i,item);
        end;
end;

procedure TFrmMain.mnuSectionAutonormalsApply(Sender: TObject);
var     scheme: TNormalsScheme;
        schemetype: String;
        results: TApplyNormalsResult;
begin
        try
                // get the scheme
                scheme := NormalsSchemes[(TMenuItem(Sender)).Tag];
                case scheme.scheme of
                        2: schemetype := 'TIBERIAN_SUN';
                        4: schemetype := 'RED_ALERT2';
                        else schemetype := '!UNEXPECTED! (' + IntToStr(scheme.scheme) + ')';
                end;
                // ask the user to confirm
                if MessageDlg('Apply this normals scheme?' + #10 +
                        'Filename: ' + scheme.FName + #10 +
                        'Author: ' + scheme.author + #10 +
                        'Scheme: ' + schemetype + #10 +
                        'WARNING! This cannot be undone!' + #10 +
                        'it is recommended you save a backup' + #10 +
                        'of this model before doing this'
                        ,mtConfirmation,[mbYes,mbNo],0) = mrNo then
                        Exit;
                ShowBusyMessage('auto-normalising');
                // clean up undo system
                UndoSystem.Clear;
                UpdateUndoStatus;
                // apply it then
                results := ApplyNormals(ActiveSection,scheme);
                HideBusyMessage;
                MajorRefresh;
                // tell the user
                with results do
                        MessageDlg('Scheme applied!' + #10 +
                                IntToStr(applied) + ' voxels applied,' + #10 +
                                IntToStr(redundant) + ' voxels are redundant (ignored) and' + #10 +
                                IntToStr(confused) + ' voxels are confused',mtInformation,[mbOK],0);
        except
                on e: Exception do begin
                        MessageDlg('Error ' + e.Message + #10 + 'Cannot apply this normals scheme',mtError,[mbCancel],0);
                end;
        end;
end;

procedure TFrmMain.SetNormalsPalette;
begin
        case ActiveSection.Tailer.Unknown of
                2: ActiveNormalsCount := MAXNORM_TIBERIAN_SUN;
                4: ActiveNormalsCount := MAXNORM_RED_ALERT2;
                else ActiveNormalsCount := 0;
        end;
        SetNormalsRamp(ActiveNormalsCount);
end;

end.
