unit FormNewProject;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, StdCtrls, ComCtrls, FileCtrl, HVA, Buttons, Menus;

type
  TFrmNewProject = class(TForm)
    IMG: TImageList;
    GroupBox1: TGroupBox;
    tip: TLabel;
    PDirGroupBox: TGroupBox;
    DriveList: TDriveComboBox;
    DirList: TDirectoryListBox;
    BtnOK: TSpeedButton;
    BtnCancel: TSpeedButton;
    DirPop: TPopupMenu;
    NewDir: TMenuItem;
    PName: TEdit;
    Label1: TLabel;
    ListView1: TListView;
    procedure DriveListChange(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure BtnCancelClick(Sender: TObject);
    procedure NewDirClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    x: integer;

  public
    { Public declarations }
    procedure SetHVAMode(HVAMode: Boolean);
  end;

var
  FrmNewProject: TFrmNewProject;

implementation

uses FormNewDir, FormMainUnit;

{$R *.DFM}

procedure TFrmNewProject.DriveListChange(Sender: TObject);
begin
  DirList.Drive := DriveList.Drive;
end;

procedure TFrmNewProject.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  BtnOk.Enabled := true;

  if Item.Index = 0 then begin //an empty voxel
    tip.Caption := 'Empty Voxel (no project, since only 1 file)';
    DirList.Enabled := false;
    DriveList.Enabled := false;
    DirList.Color := clMenu;
    DriveList.Color := clMenu;
    PName.Enabled := false;
    PName.ReadOnly := true;
    PName.Color := clMenu;
  end;

  if Item.Index=1 then begin //project
    tip.Caption := 'Empty Voxel with single-section HVA';
    DirList.Enabled := true;
    DriveList.Enabled := true;
    DirList.Color := clWindow;
    DriveList.Color := clWindow;
    PName.Enabled := True;
    PName.ReadOnly := false;
    PName.Color := clWindow;
  end;
end;

procedure TFrmNewProject.BtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmNewProject.NewDirClick(Sender: TObject);
begin
  ShowMessage(' NewDir');
  FrmNewDir.visible := true;
end;

procedure TFrmNewProject.BtnOKClick(Sender: TObject);
begin
  if ListView1.Selected.Index=0 then begin //an empty voxel
    Self.Hide;
    FrmMain.CreateNewVoxel('');
    FrmMain.lblOpenFile.Caption := 'Open File:';
    Close;
  end;
  if ListView1.Selected.Index=1 then begin //project
    CreateHVA(DirList.Directory + '\' + PName.Text+'.hva','Dummy01','HVAAnimFromVXLSe');
    FrmMain.pnlOpenFile.Caption := DirList.Directory + '\' + PName.Text+'.vxl';
    FrmMain.lblOpenFile.Caption := 'Open Project:';
    FrmMain.CreateNewVoxel(DirList.Directory + '\' + PName.Text+'.vxl');
    Close;
  end;
end;

procedure TFrmNewProject.FormCreate(Sender: TObject);
begin
  DirList.Repaint;
end;

procedure TFrmNewProject.SetHVAMode(HVAMode: Boolean);
begin
  tip.Caption := '';
  if not HVAMode then begin
    PDirGroupBox.Visible := false;
    Self.Width := 270;
    ListView1.Items.Delete(1);
  end else begin
    PDirGroupBox.Visible := true;
  end;
  ListView1.Items.Item[0].Selected:=True;
end;

end.

