unit FormOptions;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Registry, FileCtrl, ImgList, Global;

type
  TOptionsFrm = class(TForm)
    GroupBox2: TGroupBox;
    AssociateCheck: TCheckBox;
    BtnApply: TButton;
    BtnCancel: TButton;
    GroupBox1: TGroupBox;
    IconPrev: TImage;
    IconID: TTrackBar;
    IconList: TImageList;
    Run: TButton;
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnApplyClick(Sender: TObject);
    procedure IconIDChange(Sender: TObject);

  public
    IconPath: String;
    { Public declarations }
    procedure GetSettings;
    procedure ExtractIcon;
  end;

var
  OptionsFrm: TOptionsFrm;

implementation

{$R *.DFM}

procedure TOptionsFrm.ExtractIcon;
var
  sWinDir: String;
  iLength: Integer;
  Res: TResourceStream;
begin
  // Initialize Variable
  iLength := 255;
  setLength(sWinDir, iLength);
  iLength := GetWindowsDirectory(PChar(sWinDir), iLength);
  setLength(sWinDir, iLength);
  IconPath := sWinDir + '\vxlse.ico';
  Res := TResourceStream.Create(hInstance,'Icon_'+IntToStr(IconID.Position+1),RT_RCDATA);
  Res.SaveToFile(IconPath);
  Res.Free;
end;

procedure TOptionsFrm.BtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsFrm.BtnApplyClick(Sender: TObject);
var
  Reg: TRegistry;
begin
  Config.Icon:=IconID.Position;

  ExtractIcon;
  Reg :=TRegistry.Create;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  Reg.OpenKey('\VXLSe\DefaultIcon\',true);
  Reg.WriteString('',IconPath);
  Reg.CloseKey;
  Reg.Free;

if AssociateCheck.Checked = true then begin
  Config.Assoc:=True;
  Reg :=TRegistry.Create;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  Reg.OpenKey('\.vxl\',true);
  Reg.WriteString('','VXLSe');
  Reg.CloseKey;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  Reg.OpenKey('\VXLSe\shell\',true);
  Reg.WriteString('','Open');
  Reg.OpenKey('\VXLSe\shell\open\command\',true);
  Reg.WriteString('',ParamStr(0)+' %1');
  Reg.CloseKey;
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.vxl\',true);
  Reg.WriteString('Application',ParamStr(0)+' "%1"');
  Reg.CloseKey;
  Reg.Free;
  Close;
end else begin
  Config.Assoc:=False;
  Reg :=TRegistry.Create;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  Reg.DeleteKey('.vxl');
  Reg.CloseKey;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  Reg.DeleteKey('\VXLSe\');
  Reg.CloseKey;
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.DeleteKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.vxl\');
  Reg.CloseKey;
  Reg.Free;
  Close;
end;

end;

procedure TOptionsFrm.IconIDChange(Sender: TObject);
var Icon: TResourceStream;

begin
  Icon := TResourceStream.Create(hInstance,'Icon_'+IntToStr(IconID.Position+1),RT_RCDATA);
  IconPrev.Picture.Icon.LoadFromStream(Icon);
  Icon.Free;
end;

procedure TOptionsFrm.GetSettings;
begin
  AssociateCheck.Checked:=Config.Assoc;
  IconID.Position:=Config.Icon;
  IconIDChange(Self);
end;

end.
