unit cls_UndoSystem;

// TUndoSystem class
// =================
//
// Created by Koen van de Sande
//
// Revision 0.1 (12-06-2001)   NOT FINISHED YET!!!!!!
//                             THIS CLASS WILL REPLACE THE OLD UNDO SYSTEM SOON!!! 
//
// This class dynamically manages the undo system. The only thing it knows
// is that all undo information is stored inside a TMemoryStream, to which
// it returns a pointer as needed.

interface

uses Classes, Sysutils, Constants;

{$INCLUDE Global_Conditionals.inc}

type
  PMemoryStream=^TMemoryStream;
  TUndoSystem = class(TObject)
  private
    DataStreams: Array[0..MaxUndo*2-1] of TMemoryStream;
    p: Integer;  //this one points to the latest version
    NoRedo: Integer; //this indicates how many 'redo's' there still are after p.
  public
    constructor Create();
    destructor Destroy(); override;
    function GetNewActionPointer(): PMemoryStream;
    function GetUndoPointer(): PMemoryStream;
    function GetRedoPointer(): PMemoryStream;
    procedure Clear;
    function UndoLeft: Boolean;
    function RedoLeft: Boolean;
  end;

implementation

{ TUndoSystem }

procedure TUndoSystem.Clear;
var
  i: Integer;
begin
  //this is when switching section, file, etc: reset the undo system
  p:=0;
  NoRedo:=0;
  for i:=Low(DataStreams) to High(DataStreams) do begin
    DataStreams[i].Clear;
  end;
end;

constructor TUndoSystem.Create;
var
  i: Integer;
begin
  for i:=Low(DataStreams) to High(DataStreams) do begin
    DataStreams[i]:=TMemoryStream.Create;
  end;
  p:=Low(DataStreams);
  NoRedo:=0;
end;

destructor TUndoSystem.Destroy;
var
  i: Integer;
begin
  inherited;
  for i:=Low(DataStreams) to High(DataStreams) do begin
    DataStreams[i].Free;
  end;
end;

function TUndoSystem.GetNewActionPointer: PMemoryStream;
var
  i: Integer;
begin
  //we made a change!!!
  //increase undo pointer by 1
  if p=High(DataStreams) then begin  //we've reached the maximum number of undo cache. Remove oldest.
    DataStreams[Low(DataStreams)].Free;
    for i:=Low(DataStreams) to High(DataStreams)-1 do begin
      DataStreams[i]:=DataStreams[i+1];
    end;
    DataStreams[High(DataStreams)]:=TMemoryStream.Create;
    Dec(p);
  end;
  Inc(p);
  NoRedo:=0;  //we made a change, so we can't redo anymore
  DataStreams[p].Clear;
  DataStreams[p].Seek(0,soFromBeginning);
  GetNewActionPointer:=@DataStreams[p];
end;

function TUndoSystem.GetRedoPointer: PMemoryStream;
begin
  if NoRedo>0 then begin
    Inc(p);
    Dec(NoRedo);
    DataStreams[p].Seek(0,soFromBeginning);
    GetRedoPointer:=@DataStreams[p];
  end else
    GetRedoPointer:=nil;
end;

function TUndoSystem.GetUndoPointer: PMemoryStream;
begin
  if p>0 then begin
    Dec(p);
    Inc(NoRedo);
    DataStreams[p].Seek(0,soFromBeginning);
    GetUndoPointer:=@DataStreams[p];
  end else
    GetUndoPointer:=nil;
end;

function TUndoSystem.RedoLeft: Boolean;
begin
  if NoRedo>0 then RedoLeft:=True else RedoLeft:=False;
end;

function TUndoSystem.UndoLeft: Boolean;
begin
  if p>1 then UndoLeft:=True else UndoLeft:=False;
end;

end.
